DAT
{
#########################################################################################################
#                                                                                                       #
#                                                                                                       #
#           d8888 d8b  .d8888b.  888      d8b             888888b.                     d8b              #
#          d88888 Y8P d88P  Y88b 888      Y8P             888  "88b                    Y8P              #
#         d88P888     888    888 888                      888  .88P                                     #
#        d88P 888 888 888        88888b.  888 88888b.     8888888K.   8888b.  .d8888b  888  .d8888b     #
#       d88P  888 888 888        888 "88b 888 888 "88b    888  "Y88b     "88b 88K      888 d88P"        #
#      d88P   888 888 888    888 888  888 888 888  888    888    888 .d888888 "Y8888b. 888 888          #
#     d8888888888 888 Y88b  d88P 888  888 888 888 d88P    888   d88P 888  888      X88 888 Y88b.        #
#    d88P     888 888  "Y8888P"  888  888 888 88888P"     8888888P"  "Y888888  88888P' 888  "Y8888P     #
#                                             888                                                       #
#                                             888                                                       #
#                                             888                                                       #
#                                                                                                       #
#########################################################################################################
}
OBJ
{
        WARNING : Edit _XINFREQ - It is not the default 5MHz !!!
}

CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

  TV_PIN        = 12                                    ' Composite video out

  TX_PIN        = 30                                    ' -1 = Disable, 30 = TX via PropPlug, 9 = AiChip
  RX_PIN        = 31                                    ' -1 = Disable, 31 = RX via PropPlug, 8 = AiChip

  BAUD_RATE     = 38400                                 ' Auto-limits to 19200 max at 5MHz
                                                         
  KB_DAT_PIN    = 26
  KB_CLK_PIN    = 27

  I2C_SCL_PIN   = 28
  I2C_SDA_PIN   = 29

  TX_PROP_PIN   = 30
  RX_PROP_PIN   = 31
  
  CODE_SIZE_KB  = 8                                     ' How many K to allocate for user program
  
  DEMO_MODE     = true                                  ' Set for 'smart demo'
  DEMO_SAVE     = false                                 ' Save files to Eeprom
  
DAT
{

Priority Bugs

        LOAD EEPROM borks after asterixes
        
        Using variables (faked) seems to have stopped working again
        
Major bugs

        No DEC or CHR in Print
        No TAB in Print
        Variables not implmented fully
        No stack overflow checking ( stackBot =< varTop ? )
        Unary assignments not implemented
                
Minor bugs

        Get line editor storing data
        No actual Code Editor - Command Line is a fake
        Keyboard doesn't return control characters
        No line parser
        Better space insertion for list line
        Set default colour on debugging / restore to users at end
        Save/load/verify should use a percentage type bar graph to give a better report of fixed width
        #TOK debugging display is screwed
        
Known bugs

        Array DIM not implemented
        Proper Array indexing not supported
        Need / no need for dim not checked
        READ not putting data into variables
        COG command not formated
        Stack Init filling for main cog fails
        TxNumber() width > n pads leading zeroes, also need lead spaces
        numberRadix should be pushable / shiftable to allow nesting debug within print
        
Improvements

        holeMark should be derived from main cog stack used ( ie, delete holeMrk )
        Remove "numberRadix := 10" ... make number display reset this after number
        Improve Print number/width handling
        Change "Token" "GetToken" and "w" to "token"
        Remove code with @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        Make all text constants txtXXX

Need thinking about

        SD card access
        How to do single line execution
        How to do single statement stepping
        How to do the actual code editing
                     
}
PRI Version

  result := String( "AiChip Basic 003" )
        
DAT
{

    8888888          d8b 888    d8b          888 d8b                   888    d8b                   
      888            Y8P 888    Y8P          888 Y8P                   888    Y8P                   
      888                888                 888                       888                          
      888   88888b.  888 888888 888  8888b.  888 888 .d8888b   8888b.  888888 888  .d88b.  88888b.  
      888   888 "88b 888 888    888     "88b 888 888 88K          "88b 888    888 d88""88b 888 "88b 
      888   888  888 888 888    888 .d888888 888 888 "Y8888b. .d888888 888    888 888  888 888  888 
      888   888  888 888 Y88b.  888 888  888 888 888      X88 888  888 Y88b.  888 Y88..88P 888  888 
    8888888 888  888 888  "Y888 888 "Y888888 888 888  88888P' "Y888888  "Y888 888  "Y88P"  888  888 

}
CON

  MAGIC_NUMBER  = $DEAD_D0D0

OBJ

  tv            : "AiChip_Basic_Tv_001"
' tv            : "AiChip_Basic_TvBest_001"
  kb            : "AiChip_Basic_Keyboard_001"
  
  i2c           : "AiChip_Basic_I2C_001"

VAR

  byte runningFromRom
    
PUB Main

  CogNewStack( word[ $000E ] , 0 )
  CogSetInfo( CogId , Version )

  CogNewStack( 0, 0 )
  CogSetInfo( 1 , tv.Version )
  tv.Open(  TV_PIN, 0 )

  KbInit

  FileOpenConsole

  EepromOpen( 0 )  

  if TX_PIN == 30 
    if runningFromRom == 0
      i2c.WriteByte( @runningFromRom, -1 )
      WaitCnt( CLKFREQ * 5 + CNT )
    
  if ( @result + 256 | 1023 ) + 1 > CODE_BASE
    Str( String( $0D,"Decr CODE_SIZE_KB" ) )
    repeat

  BuildOpcLookupTable

  if not DEMO_MODE
'==    debug :=  DEBUG_SHOWLINE | DEBUG_SHOWVARDEF | DEBUG_SHOWEXPR       ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  FlushCode
  StatHelpMain

  if DEMO_SAVE
    if IsAnythingSavedToEeprom
      Type( String( "LOAD EEPROM" ) )
      LoadCodeFromEeprom

  if not IsCodeLoadedSameAsCodeSaved
  
    PushNum( 10 )
    PushOpc( @opcPRINT)
    PushTxt( String("Hello") )
    PushOpc( @symCOMMA )
    pushopc( @symINC )
    PushOpc( @opcWORD )
    PushOpc( @symLBRACKET )
    PushOpc( @tagHEX )
    PushNum( $7FC0 )
    PushOpc( @symRBRACKET )
    pushopc( @symINC )
    PushOpc( @tagEOL )

    {
    PushNum(15)
    PushOpc( @opcDATA )
    PushTxt( String("HELLO") )
    PushOpc( @symCOMMA )
    PushNum( 2 )
    PushOpc( @symCOLON )
    PushOpc( @opcREAD )
    PushOpc( @symCOLON )
    PushOpc( @opcREAD )
    PushOpc( @tagEOL)
    }
    
    PushNum( 20 )
    pushopc( @opcCOLOR )
    pushnum( 3 )
    pushopc( @symCOLON )
    PushOpc( @opcPRINT)
    PushTxt( String("Hello") )
    PushOpc( @symCOMMA )
    PushOpc( @opcWORD )
    PushOpc( @symLBRACKET )
    PushOpc( @tagHEX )
    PushNum( $7FC0 )
    PushOpc( @symRBRACKET )
    pushopc( @symINC )
    PushOpc( @tagEOL)

    PushNum( 30 )
    PushOpc( @opcPRINT)
    PushTxt( String("Hello") )
    PushOpc( @symCOMMA )
    PushOpc( @opcWORD )
    PushOpc( @symLBRACKET )
    PushOpc( @tagHEX )
    PushNum( $7FC0 )
    PushOpc( @symRBRACKET )
    pushopc( @symINC )
    PushOpc( @tagEOL)

    { 
    PushNum( 20 )
    PushVar( String( "myVar" ) )
    PushOpc( @symEQ )
    PushNum( 1 )
    PushOpc( @symCOLON)
    PushVar( String( "myVar" ) )
    PushOpc( @symADDEQ )
    PushOpc( @opcWORD )
    PushOpc( @symLBRACKET )
    PushOpc( @tagHEX )
    PushNum( $7FC0 )
    PushOpc( @symRBRACKET )
    PushOpc( @tagEOL)
     
    PushNum( 30 )
    PushOpc( @opcPRINT)
    PushTxt( String("World") )
    PushOpc( @symCOMMA )
    PushVar( String("myVar") )
    PushOpc( @symDOT )
    PushOpc( @opcBYTE )
    PushOpc( @tagEOL )

    }

    if DEMO_MODE
     
      PushNum( 40 )
      PushOpc( @opcWAITCNT )
      PushOpc( @opcCLKFREQ)
      if DEMO_MODE
        pushOpc( @symMPY )
        PushNum( 10 )
      PushOpc( @symADD )
      pushReg( $1F1 )           ' CNT
      PushOpc( @symCOLON )
      {
      PushOpc( @opcGOTO )
      PushNum( 30 )
      PushOpc( @symCOLON )
      }
      PushOpc( @opcEND )
      pushOpc( @tagEOL )
     
    PushOpc( @tagEOF )

  Type( String( "LIST" ) )
  ListLines( 0, 0 )

  if DEMO_SAVE
    if not IsCodeLoadedSameAsCodeSaved
      Type( String( "SAVE EEPROM" ) )
      SaveCodeToEeprom

  Type( String( "RUN" ) )

  result := \Execute

  TvColor( 0 )

  OnNewLine 
  if result < 0 or byte[ result ] == "*"
    if result < 0
      -result
    else
      ++result
    if byte[ result ] == "{"
      result += StrSize( result ) + 1
    Str( result )
    Str( String( " expected" ) )
  else
    Str( result )

  if lastLineNumber => 0 
    Str( String(" in Line ") )
    Dec( lastLineNumber )
    if result == @aboFINISHED
      Out( $0D)
    else
      Str( String( " ...",$0D ) )
      ListLine( lastLinePc )

  Type( String( "VARS" ) )
  ListVars
  Type( String( "COGS" ) )
  ListCogs
  Type( String( "LIST OPEN" ) )
  ListFiles( FILE_MODE_OPEN )
  Type( String( "MEM" ) )
  ListMemory( false )

  BuildCommandLine
  
DAT
{                                                                                                    

               888b     d888          d8b             888                                
               8888b   d8888          Y8P             888                                
               88888b.d88888                          888                                
               888Y88888P888  8888b.  888 88888b.     888      .d88b.   .d88b.  88888b.  
               888 Y888P 888     "88b 888 888 "88b    888     d88""88b d88""88b 888 "88b 
               888  Y8P  888 .d888888 888 888  888    888     888  888 888  888 888  888 
               888   "   888 888  888 888 888  888    888     Y88..88P Y88..88P 888 d88P 
               888       888 "Y888888 888 888  888    88888888 "Y88P"   "Y88P"  88888P"  
                                                                                888      
                                                                                888      
                                                                                888
                                                                                      
}
VAR

  long pc
  long lastPc
  long statPc
  long nextPc

  long dataPc
  
  word lastLineNumber
  long lastLinePc

PRI Execute

  ResetCode

  pc := codeBot
  nextPc := 0
  dataPc := pc
  lastLineNumber := 0

  Token
  repeat
    Statement

PRI ExecuteThis( n )

  pc := n
  nextPc := 0
  lastLineNumber := 0
  
  Token
  Statement

PRI Statement

  if nextPc
    pc := nextPc~
    Token

  lastLinePc := lastPc
   
  if w == @tagNUMBER
    lastLineNumber := v
    if debug & DEBUG_SHOWLINE
      Dbg( String( "LIN") )
      Dec( lastLineNumber )
      Out( " " )
      debug |= DEBUG_GAVELNUM
    Token
    
  SkipColon
  SingleStatement
  repeat while w == @symCOLON and nextPc == 0
    SkipColon    
    SingleStatement

  if nextPc
    CheckEol
  else
    CheckHardEol
    if byte[ pc ] == lookupAtTagEOF
      Abort @aboFINISHED
    Want( @tagEOL )
    
PRI SingleStatement

  CheckBreak
    
  statPc := lastPc

  if debug & DEBUG_SHOWLINE
    if debug & DEBUG_GAVELNUM
      debug ^= DEBUG_GAVELNUM
    else
      Dbg( String( "LIN") )
    ListLine( statPc )
    
  case w
    @tagEOL    :
    
    @opcEND    : StatEnd
    @opcIF     : StatIf
    @opcELSE   : StatElse
'   @opcELSEIF
    @opcENDIF  : StatEndIf
    @opcREPEAT : StatRepeat
    @opcUNTIL  : StatUntil
    @opcWHILE  : StatWhile
    @opcWEND   : StatWend
'   @opcSELECT
'   @opcCASE
'   @opcFOR
'   @opcNEXT
'   @opcSUB
'   @opcENDSUB
'   @opcFUNCTION
'   @opcENDFUNC
        
    other :
      if conditional[ condTop ]
        case w

          @opcBREAK   : StatBreak
'         @opcCALL
          @opcCLOSE   : StatClose
          @opcCLS     : StatCls
          @opcCOGS    : StatCogs
          @opcCOLOR   : StatColor
          @opcCOLOUR  : StatColor
          @opcDATA    : StatData
'         @opcDEF
          @opcDIM     : StatDim
'         @opcERROR
'         @opcEXIT
          @opcGOTO    : StatGoto
          @opcGOSUB   : StatGosub
          @opcHELP    : StatHelp
          @opcHIGH    : StatHigh_Low_Toggle( TX_CMD_HIGH )
'         @opcINPUT
'         @opcKILL
          @opcLOAD    : StatLoad
          @opcLOCATE  : StatLocate
          @opcLOW     : StatHigh_Low_Toggle( TX_CMD_LOW )
'         @opcMODE
          @opcMEM     : StatMem
'         @opcNAME
          @opcNEW     : StatNew
'         @opcON
          @opcOPEN    : StatOpen
'         @opcOUTPUT
          @opcPAUSE   : StatPause
'         @opcPOP
          @opcPRINT   : StatPrint
'         @opcPUSH
'         @opcQUIT
'         @opcRANDOM
          @opcREAD    : StatRead
'         @opcRENUM
          @opcRESTORE : StatRestore
          @opcRETURN  : StatReturn
          @opcRUN     : StatRun
          @opcSAVE    : StatSave
'         @opcSHELL
'         @opcSTART
'         @opcSTEP
'         @opcSTOP
'         @opcSYSTEM
          @opcTOGGLE  : StatHigh_Low_Toggle( TX_CMD_TOGGLE )
          @opcUSER    : StatUser
          @opcVARS    : StatVars
          @opcWAITCNT : StatWaitCnt
          @opcWAITPEQ : StatWaitPxx
          @opcWAITPNE : StatWaitPxx

          @opcLET     : Token
                        Assignment
                        
          @tagVAR, @tagNEW, @tagREG, @opcSPR, @opcBYTE, @opcWORD, @opcLONG, @opcEEPROM, @symINC, @symDEC :
                        Assignment
                        
          @symSUB, @symNOT, @symABS, @symSQR, @symRND, @opcLOGNOT, @opcRANDOM :
                        UnaryAssignment

          other : Abort @aboSTATEMENT_EXPECTED
      else
        repeat
          Token
        until w == @tagEOL or w == @symCOLON

  CheckEol
     
PRI SkipColon

  if w == @symCOLON
    Token
    repeat while w == @symCOLON
      Token

PRI CheckEol

  if w <> @tagEOL and w <> @symCOLON
    Abort -@tagEOL

PRI CheckHardEol

  if w <> @tagEOL
    Abort -@tagEOL
              
PRI Want( n )

  if w <> n
    Abort -n
  Token

PRI CheckBreak

  if rxBreak~ or kbBreak~
    Abort @opcBREAK
    
DAT
{

        .d8888b.  888             888                                            888             
       d88P  Y88b 888             888                                            888             
       Y88b.      888             888                                            888             
        "Y888b.   888888  8888b.  888888 .d88b.  88888b.d88b.   .d88b.  88888b.  888888 .d8888b  
           "Y88b. 888        "88b 888   d8P  Y8b 888 "888 "88b d8P  Y8b 888 "88b 888    88K      
             "888 888    .d888888 888   88888888 888  888  888 88888888 888  888 888    "Y8888b. 
       Y88b  d88P Y88b.  888  888 Y88b. Y8b.     888  888  888 Y8b.     888  888 Y88b.       X88 
        "Y8888P"   "Y888 "Y888888  "Y888 "Y8888  888  888  888  "Y8888  888  888  "Y888  88888P' 
                                                                                                 
}
DAT
{
         ___  ___   ___   __   _ _  
        (  ,)(  ,) (  _) (  ) ( ) ) 
         ) ,\ )  \  ) _) /__\  )  \ 
        (___/(_)\_)(___)(_)(_)(_)\_)
}

PRI StatBreak

  ' BREAK # file, expr_mS

  Token
  StatBreakPart( TX_CMD_BREAK )
  
PRI StatBreakPart( txCmdValue ) | f
  
  Want( @symHash )
  f := FileNumber
  if fileMode[f] & FILE_MODE_OUTPUT
    Want( @symCOMMA )
    TxPut( txCmdValue | f, Expr <# 255 )
  else
    Abort @aboBAD_FILE_MODE

DAT
{
          __   __   __    __
         / _) (  ) (  )  (  )
        ( (_  /__\  )(__  )(__
         \__)(_)(_)(____)(____)
}
DAT
DAT
{
          __  __    __   ___  ___
         / _)(  )  /  \ / __)(  _)
        ( (_  )(__( () )\__ \ ) _)
         \__)(____)\__/ (___/(___)
}

PRI StatClose

  ' CLOSE
  ' CLOSE # file { , {#} file ... }
  
  Token
  if w == @tagEOL
    FileCloseAll
  else
    Want( @symHASH )
    FileClose( FileNumber )
    repeat while w == @symCOMMA
      Token
      if w == @symHASH
        Token
      FileClose( FileNumber )
        
DAT
{
          __  __    ___
         / _)(  )  / __)
        ( (_  )(__ \__ \
         \__)(____)(___/
}

PRI StatCls | n 

  ' CLS { , mode }
  
  Token
  if w ==  @tagEOL
    TvCls
  else
    n := Expr
    CheckEol
    TvMode( n )
  
DAT
{
          __  __    __  ___ 
         / _)/  \  / _)/ __)
        ( (_( () )( (/\\__ \
         \__)\__/  \__/(___/

}

PRI StatCogs

  ' COGS
  
  Token
  CheckEol
  ListCogs
  
DAT
{
          __  __  __    __  ___       _       __  __  __    __  _  _  ___  
         / _)/  \(  )  /  \(  ,)    _( )_    / _)/  \(  )  /  \( )( )(  ,)
        ( (_( () ))(__( () ))  \   (_   _)  ( (_( () ))(__( () ))()(  )  \ 
         \__)\__/(____)\__/(_)\_)    (_)     \__)\__/(____)\__/ \__/ (_)\_)

}

PRI StatColor | n

  ' COLOR color
  ' COLOR color AS palettesetting
  
  Token
  n := Expr & $F
  TvColor( n )
    
DAT
{
         ___   __  ____  __
        (   \ (  )(_  _)(  )
         ) ) )/__\  )(  /__\
        (___/(_)(_)(__)(_)(_)
}

PRI StatData

  ' DATA expr { , expr ... }
  
  StatDataPart
  repeat while w == @symCOMMA
    StatDataPart

PRI StatDataPart

  Token
  Expr
  
DAT
{
         ___  ___  ___  _  _  __ 
        (   \(  _)(  ,)( )( )/ _)
         ) ) )) _) ) ,\ )()(( (/\
        (___/(___)(___/ \__/ \__/
}
DAT   
DAT
{
         ___  ___  ___
        (   \(  _)(  _)
         ) ) )) _) ) _)
        (___/(___)(_)
}
DAT
DAT
{
         ___  __  __  __
        (   \(  )(  \/  )
         ) ) ))(  )    (
        (___/(__)(_/\/\_)
}

PRI StatDim

  ' DIM var ( expr )
  ' DIM var [ expr ]
  
  StatDimPart
  repeat while w == @symCOMMA
    StatDimPart

PRI StatDimPart | byteSize, varSize
  Token
  if w == @tagVAR
    Abort @aboALREADY_DEFINED
  if w <> @tagNEW
    Abort -@tagVAR
  varSize := GetVarSizeFromType( varType )
  Token
  if w == @symLPARA
    Token
    byteSize := StatDimSize(1)
    Want( @symRPARA )
  else
    Want( @symLBRACKET )
    byteSize := StatDimSize(0)
    Want( @symRBRACKET )
  byteSize *= varSize
  ' @@@@@@@@@@@
  
PRI StatDimSize( n ) : byteSize | thisSize

  if ( byteSize := ( Expr + n ) ) =< 0
    Abort @aboBAD_DIM_SIZE
  repeat while w == @symCOMMA
    Token
    if ( thisSize := ( Expr + n ) ) =< 0
      Abort @aboBAD_DIM_SIZE
    byteSize *= thisSize 

DAT
{
         ___  _  _  ___
        (  _)( \( )(   \
         ) _) )  (  ) ) )
        (___)(_)\_)(___/
}

PRI StatEnd

  ' END
  ' END IF
  ' END WHILE
  
  Token
  case w
    @tagEOL   : if conditional[ condTop ]
                  Abort @aboFINISHED
    @opcIF    : StatEndIf
    @opcWHILE : StatWend
    
DAT
{
         ___  ___   ___   __  ___
        (  _)(  ,) (  ,) /  \(  ,)
         ) _) )  \  )  \( () ))  \
        (___)(_)\_)(_)\_)\__/(_)\_)
}
DAT
DAT
{
         ___  _  _  __  ____
        (  _)( \/ )(  )(_  _)
         ) _) )  (  )(   )(
        (___)(_/\_)(__) (__)
}
DAT
DAT
{
         ___   __  ___            _  _  ___  _  _  ____ 
        (  _) /  \(  ,)    ___   ( \( )(  _)( \/ )(_  _)
         ) _)( () ))  \   (___)   )  (  ) _) )  (   )(  
        (_)   \__/(_)\_)         (_)\_)(___)(_/\_) (__) 
}
DAT
DAT
{
         ___  _  _  _  _  __  ____  __  __  _  _
        (  _)( )( )( \( )/ _)(_  _)(  )/  \( \( )
         ) _) )()(  )  (( (_   )(   )(( () ))  (
        (_)   \__/ (_)\_)\__) (__) (__)\__/(_)\_)
}
DAT
DAT
{
          __   __   ___  _  _  ___
         / _) /  \ / __)( )( )(  ,)
        ( (/\( () )\__ \ )()(  ) ,\
         \__/ \__/ (___/ \__/ (___/
}

PRI StatGosub

  ' GOSUB linenumber
  ' GOSUB * variable

  nextPc := PreCachedLineNumber
  PushWord( lastPc )
  CondPush( true, @opcRETURN )
  
DAT
{
          __   __  ____  __
         / _) /  \(_  _)/  \
        ( (/\( () ) )( ( () )
         \__/ \__/ (__) \__/

}
PRI StatGoto

  ' GOTO linenumber
  ' GOTO * variable

  nextPc := PreCachedLineNumber
  
DAT
{
         _  _  ___  __    ___ 
        ( )( )(  _)(  )  (  ,\
         )__(  ) _) )(__  ) _/
        (_)(_)(___)(____)(_)  
         
}
PRI StatHelp

  ' HELP
  
  Token
  CheckEol
  StatHelpMain
  Str( String( "http://forums.parallax.com/forums/default.aspx?f=25&m=264289",$0D ))

PRI StatHelpMain

  Str( Version )
  Str( String( " - " ) )
  Dkb( $8000 - CODE_BASE )
  Out( " " )
  Mhz( CLKFREQ )
  Str( String( "MHz",$0D,$0D ) )

DAT
{
         _  _  __  __  _  _ 
        ( )( )(  )/ _)( )( )
         )__(  )(( (/\ )__( 
        (_)(_)(__)\__/(_)(_)
}

PRI StatHigh_Low_Toggle( txCmdValue )

  ' HIGH # file { , {#} file ... }
  
  Token
  Want( @symHASH )
  StatHigh_Low_Toggle_Part( txCmdValue )
  repeat while w == @symCOMMA
    Token
    if w == @symHASH
      Token
    StatHigh_Low_Toggle_Part( txCmdValue )

PRI StatHigh_Low_Toggle_Part( txCmdValue ) | f

  f := FileNumber
  if fileMode[f] & FILE_MODE_OUTPUT
    TxPut( txCmdValue | f, 0 )
  else
    Abort @aboBAD_FILE_MODE
   
DAT
{
         __  ___           ___  __    ___  ___           ___  _  _  ___     __  ___ 
        (  )(  _)   ___   (  _)(  )  / __)(  _)   ___   (  _)( \( )(   \   (  )(  _)
         )(  ) _)  (___)   ) _) )(__ \__ \ ) _)  (___)   ) _) )  (  ) ) )   )(  ) _)
        (__)(_)           (___)(____)(___/(___)         (___)(_)\_)(___/   (__)(_) 
}

PRI StatIf

  ' IF expr {THEN}
  ' ENDIF

  ' IF expr {THEN}
  ' ELSE
  ' ENDIF

  ' IF expr THEN stat { ELSE stat }
    
  Token
  CondPush( Expr, @opcELSE )
  if w == @opcTHEN
    Token
    if w <> @tagEOL
      SingleStatement
      CondPop( @opcELSE )
      if w == @opcELSE
        CondPush( not conditional[ condTop+1 ], @opcENDIF )
        Token
        SingleStatement
        CondPop( @opcENDIF )
        
PRI StatElse

  ' IF expr {THEN}
  ' ELSE
  ' ENDIF

  CondPop( @opcELSE )
  CondPush( not conditional[ condTop+1 ], @opcENDIF )
  Token
      
PRI StatEndIf

  ' IF expr {THEN}
  ' ENDIF

  ' IF expr {THEN}
  ' ELSE
  ' ENDIF

  if condWant[ condTop ] == @opcELSE
    CondPop( @opcELSE )
  else
    CondPop( @opcENDIF )
  Token
        
DAT
{
         __  _  _  ___  _  _  ____
        (  )( \( )(  ,\( )( )(_  _)
         )(  )  (  ) _/ )()(   )(
        (__)(_)\_)(_)   \__/  (__)
}
DAT
DAT
{
         _ _   __  __    __
        ( ) ) (  )(  )  (  )
         )  \  )(  )(__  )(__
        (_)\_)(__)(____)(____)
}
DAT
DAT
{
         __    __  ___  ____
        (  )  (  )/ __)(_  _)
         )(__  )( \__ \  )(
        (____)(__)(___/ (__)
}

PRI StatList

  ' LIST
  ' LIST linenumber
  ' LIST linenumber, count

  ' LIST COGS
  ' LIST EEPROM
  ' LIST MEM
  ' LIST VARS
  ' LIST OPEN
  ' LIST INPUT
  ' LIST OUTPUT
  
  Token  
  if w == @tagEOL
    ListLines( listFrom, listCount )
  else
    case w
      @opcCOGS   : ListCogs
      @opcEEPROM : ListEeprom
      @opcMEM    : ListMemory( true )
      @opcINPUT  : ListFiles( FILE_MODE_INPUT )
      @opcOPEN   : ListFiles( FILE_MODE_OPEN )
      @opcOUTPUT : ListFiles( FILE_MODE_OUTPUT )
      @opcVARS   : ListVars
      other :
        listFrom := LineNumber
        if w == @symCOMMA
          Token
          listCount := PositiveNumber
        CheckEol
        ListLines( listFrom, listCount )

DAT
{
         __    __   __   ___
        (  )  /  \ (  ) (   \
         )(__( () )/__\  ) ) )
        (____)\__/(_)(_)(___/
}

PRI StatLoad

  ' LOAD EEPROM
  
  Token
  Want( @opcEEPROM )
  LoadCodeFromEeprom

DAT
{
         __    __    __   __  ____  ___ 
        (  )  /  \  / _) (  )(_  _)(  _)
         )(__( () )( (_  /__\  )(   ) _)
        (____)\__/  \__)(_)(_)(__) (___)
}

PRI StatLocate | n

  ' LOCATE row { , column }
  
  Token
  n := PositiveNonZeroNumber
  if w == @symCOMMA
    Token
    TvAt( n , PositiveNonZeroNumber )
  else
    TvAtRow( n )

DAT
{
         __    __  _    _ 
        (  )  /  \( \/\/ )
         )(__( () )\    / 
        (____)\__/  \/\/  
}
DAT '   See High Statement
DAT
{
         __  __  ___  __  __
        (  \/  )(  _)(  \/  )
         )    (  ) _) )    (
        (_/\/\_)(___)(_/\/\_)
}


PRI StatMem | n

  ' MEM
  ' MEM LIST
  
  Token
  if ( n := ( w == @opcLIST ) )
    Token 
  CheckEol
  ListMemory( n )

DAT
{
         __  __  __  ___  ___ 
        (  \/  )/  \(   \(  _)
         )    (( () )) ) )) _)
        (_/\/\_)\__/(___/(___)
}
DAT
DAT
{
         _  _   __   __  __  ___
        ( \( ) (  ) (  \/  )(  _)
         )  (  /__\  )    (  ) _)
        (_)\_)(_)(_)(_/\/\_)(___)
}
DAT
DAT
{
         _  _  ___  _    _
        ( \( )(  _)( \/\/ )
         )  (  ) _) \    /
        (_)\_)(___)  \/\/
}

PRI StatNew

  ' NEW
  
  Token
  Want( @tagEOL )
  FlushCode
  abort @aboFINISHED
         
DAT
{
          __  _  _
         /  \( \( )
        ( () ))  (
         \__/(_)\_)
}
DAT
DAT
{
          __  ___  ___  _  _
         /  \(  ,\(  _)( \( )
        ( () )) _/ ) _) )  (
         \__/(_)  (___)(_)\_)
}

PRI StatOpen

  ' OPEN pin,baud,parity,databits,stopbits FOR INPUT|OUTPUT AS # file
  
  Token
  
  '   OPEN  pin          , baud         , parity       , data         , stop  FOR mode AS #  file      
  FileOpen( StatOpenExpr1, StatOpenExpr1, StatOpenExpr1, StatOpenExpr1, Expr, StatOpenExpr2, FileNumber )

PRI StatOpenExpr1

  result := Expr
  Want( @symCOMMA )

PRI StatOpenExpr2

  Want( @opcFOR )
  case w
    @opcINPUT  : result := FILE_MODE_INPUT
    @opcOUTPUT : result := FILE_MODE_OUTPUT
    other      : Abort @aboSYNTAX_ERROR
  Want( @opcAS )
  Want( @symHASH )
     
DAT
{
          __  _  _  ____  ___  _  _  ____
         /  \( )( )(_  _)(  ,\( )( )(_  _)
        ( () ))()(   )(   ) _/ )()(   )(
         \__/ \__/  (__) (_)   \__/  (__)
}
DAT
DAT
{
         ___  __  _  _  ___  ___
        (  ,\(  )( )( )/ __)(  _)
         ) _//__\ )()( \__ \ ) _)
        (_) (_)(_)\__/ (___/(___)
}

PRI StatPause | nMs, nUs

  ' PAUSE expr_mS { , expr_uS }

  ' PAUSE # file, expr_mS
  
  Token
  if w == @symHASH
    StatBreakPart( TX_CMD_PAUSE )
  else
    nMs := PositiveNumber
    if w == @symCOMMA
      Token
      if ( nUs := PositiveNumber )
        if nMs
          nMs -= 1
          nUs += 1000
        else
          nUs #>= 500
        WaitCnt( CLKFREQ / 1_000_000 * nUs + CNT )
    repeat nMs
      CheckBreak
      WaitCnt( CLKFREQ / 1_000 + CNT )
    
DAT
{
         ___  ___   __  _  _  ____
        (  ,\(  ,) (  )( \( )(_  _)
         ) _/ )  \  )(  )  (   )(
        (_)  (_)\_)(__)(_)\_) (__)
}

PRI StatPrint : givenCrLf

  fileHandle := 0
  Token
  if w <> @tagEOL
    if w == @symHASH
      Token
      fileHandle := PositiveNumber
      Want( @symCOMMA )
      givenCrlF := StatPrintPart
    else
      givenCrLf := StatPrintPart
  if not givenCrLf
    Out( $0D )
  fileHandle := 0
    
PRI StatPrintPart : givenCrLf

  StatPrintPartOne
  repeat while ( w == @symCOMMA ) or ( w == @symSEMICOLON )
    givenCrLf := false
    if w == @symCOMMA
      Out( $09 )
      Token
      if w <> @symCOMMA
        StatPrintPartOne
    else
      Token
      if not ( givenCrlf := ( w == @tagEOL ) )
        StatPrintPartOne
          
PRI StatPrintPartOne | n, s

  case w
    @opcHEX, @opcBIN, @opcDEC, @opcSTR :
      case w
        @opcBIN : numberRadix := 2
        @opcDEC : numberRadix := 10
        @opcHEX : numberRadix := 16
      Token
      Want( @symLPARA )
      n := Expr
      if w == @symCOMMA
        Token
        s := Expr
      else
        s := 0
      Want( @symRPARA )
      OutNumberFormat( n, numberRadix, s )
      numberRadix := 10
    @tagTXT :
      printString( v, s )
      Token
    other :
      Dec( Expr )

PRI PrintString( n, s )

  if n < codeBot  ' @@@@@ If not held in opcode area
    Str( n )    ' @@@@@ Add size to this
  else
    repeat
      if ( result := byte[ n++ ] ) & $7F
        ListTextChar( result & $7F )
    while ( result & $80 ) and ( --s <> 0 ) 
   

DAT
{
         ___  _  _  ___  _  _           ___   __  ___ 
        (  ,\( )( )/ __)( )( )   ___   (  ,\ /  \(  ,\
         ) _/ )()( \__ \ )__(   (___)   ) _/( () )) _/
        (_)   \__/ (___/(_)(_)         (_)   \__/(_)  

}
DAT
DAT
{
          __  _  _  __  ____
         /  \( )( )(  )(_  _)
        ( () ))()(  )(   )(
         \___\\__/ (__) (__)
}
DAT
DAT
{
         ___    __   _  _  ___    __  __  __
        (  ,)  (  ) ( \( )(   \  /  \(  \/  )
         )  \  /__\  )  (  ) ) )( () ))    (
        (_)\_)(_)(_)(_)\_)(___/  \__/(_/\/\_)
}
DAT
DAT
{
         ___   ___   __   ___
        (  ,) (  _) (  ) (   \
         )  \  ) _) /__\  ) ) )
        (_)\_)(___)(_)(_)(___/
}

PRI StatRead

  StatReadPart
  repeat while w == @symCOMMA
    StatReadPart

PRI StatReadPart

  TokenPushState

  pc := || dataPc
  Token
  if dataPc > 0
    repeat while w <> @opcDATA
      Token
    Token
  result := Expr
  if w == @symCOMMA
    dataPc := -Pc
  else
     CheckEol
     dataPc := pc

  TokenPopState

  Token
  
DAT
{
         ___   ___  _  _  _  _  __  __
        (  ,) (  _)( \( )( )( )(  \/  )
         )  \  ) _) )  (  )()(  )    (
        (_)\_)(___)(_)\_) \__/ (_/\/\_)
}
DAT
DAT
{
         ___   ___  ___  ___   __  ____           _  _  _  _  ____  __  __   
        (  ,) (  _)(  ,\(  _) (  )(_  _)   ___   ( )( )( \( )(_  _)(  )(  )  
         )  \  ) _) ) _/ ) _) /__\  )(    (___)   )()(  )  (   )(   )(  )(__ 
        (_)\_)(___)(_)  (___)(_)(_)(__)           \__/ (_)\_) (__) (__)(____)
}
PRI StatRepeat

  ' REPEAT
  ' UNTIL expr

  ' REPEAT
  ' WHILE expr

  Token
  CondPush( true, @opcUNTIL )

PRI StatUntil

  ' REPEAT
  ' UNTIL expr

  Token
  CondPop( @opcUNTIL )
  If not Expr
    if conditional[ condTop+1 ]
      nextPc := condAtPc[ condTop+1 ]

DAT
{
         ___   ___  ___  ____  __  ___   ___
        (  ,) (  _)/ __)(_  _)/  \(  ,) (  _)
         )  \  ) _)\__ \  )( ( () ))  \  ) _)
        (_)\_)(___)(___/ (__) \__/(_)\_)(___)
}

PRI StatRestore

  ' RESTORE
  ' RESTORE linenumber
  ' RESTORE * variable
  
  Token
  if w <> @tagEOL
    dataPc := LineNumber
  else
    dataPc := codeBot

DAT
{
         ___   ___  ____  _  _  ___   _  _
        (  ,) (  _)(_  _)( )( )(  ,) ( \( )
         )  \  ) _)  )(   )()(  )  \  )  (
        (_)\_)(___) (__)  \__/ (_)\_)(_)\_)
}

PRI StatReturn

  ' RETURN
  
  Token
  CheckhardEol

  if condTop =< 0
    Abort @aboNESTING_ERROR
  
  repeat while condWant[ condTop ] == @opcRETURN
    if --condTop =< 0
      Abort @aboNESTING_ERROR
  
  nextPc := PopWord
  
DAT
{
         ___  _  _  _  _
        (  ,)( )( )( \( )
         )  \ )()(  )  (
        (_)\_)\__/ (_)\_)
}

PRI StatRun

  ' RUN
  ' RUN linenumber
  ' RUN * variable
  
  Token
  if w <> @tagEOL
    nextPc := LineNumber
  else
    nextPc := codeBot
  CheckHardEol
  ResetCode
  
DAT
{
         ___   __  _  _  ___
        / __) (  )( )( )(  _)
        \__ \ /__\ \\//  ) _)
        (___/(_)(_)(__) (___)
}

PRI StatSave

  ' SVAE EEPROM
  
  Token
  Want( @opcEEPROM )
  SaveCodeToEeprom
  
DAT
{
         ___  ___  ___  _ _
        / __)(  _)(  _)( ) )
        \__ \ ) _) ) _) )  \
        (___/(___)(___)(_)\_)
}
DAT
DAT
{
         ___  ___  __    ___   __  ____            __   __   ___  ___ 
        / __)(  _)(  )  (  _) / _)(_  _)   ___    / _) (  ) / __)(  _)
        \__ \ ) _) )(__  ) _)( (_   )(    (___)  ( (_  /__\ \__ \ ) _)
        (___/(___)(____)(___) \__) (__)           \__)(_)(_)(___/(___)
}
DAT
DAT
{
         ___  _  _  ___  __    __
        / __)( )( )(  _)(  )  (  )
        \__ \ )__(  ) _) )(__  )(__
        (___/(_)(_)(___)(____)(____)
}
DAT
DAT
{
         ___  ____  __   ___  ____
        / __)(_  _)(  ) (  ,)(_  _)
        \__ \  )(  /__\  )  \  )(
        (___/ (__)(_)(_)(_)\_)(__)
}
DAT
DAT
{
         ___  ____  ___  ___
        / __)(_  _)(  _)(  ,\
        \__ \  )(   ) _) ) _/
        (___/ (__) (___)(_)
}
DAT
DAT
{
         ___  ____  __  ___
        / __)(_  _)/  \(  ,\
        \__ \  )( ( () )) _/
        (___/ (__) \__/(_)
}
DAT
DAT
{
         ___  _  _  ___
        / __)( )( )(  ,)
        \__ \ )()(  ) ,\
        (___/ \__/ (___/
}
DAT
DAT
{
         ___  _  _  ___  ____  ___  __  __
        / __)( \/ )/ __)(_  _)(  _)(  \/  )
        \__ \ \  / \__ \  )(   ) _) )    (
        (___/(__/  (___/ (__) (___)(_/\/\_)
}
DAT
DAT
{
         ____  __    __   __  __    ___ 
        (_  _)/  \  / _) / _)(  )  (  _)
          )( ( () )( (/\( (/\ )(__  ) _)
         (__) \__/  \__/ \__/(____)(___)
}
DAT '    See High Statement
DAT
{
         _  _  ___  ___  ___
        ( )( )/ __)(  _)(  ,)
         )()( \__ \ ) _) )  \
         \__/ (___/(___)(_)\_)
}

PRI StatUser | n

  ' USER expr
  
  Token
  if ( n := PositiveNumber )
    if varsTop > varsBot
      if n
        ByteMove( varsBot+n, varsBot, varsTop-varsBot+1 )
        varsBot += n
        varsTop += n
        ResetVars ' Change all @tagVAR to @tagNEW so addresses are re-linked
 
DAT
{
         _  _  __   ___   ___
        ( )( )(  ) (  ,) / __)
         \\// /__\  )  \ \__ \
         (__)(_)(_)(_)\_)(___/
}

PRI StatVars

  ' VARS
  
  Token
  CheckEol
  ListVars
  
DAT
{
         _    _  __   __  ____  __  _  _  ____
        ( \/\/ )(  ) (  )(_  _)/ _)( \( )(_  _)
         \    / /__\  )(   )( ( (_  )  (   )(
          \/\/ (_)(_)(__) (__) \__)(_)\_) (__)
}

PRI StatWaitCnt | n

  ' WAITCNT expr
  
  Token
  n := Expr
  CheckEol
  WaitCnt( n )

DAT
{
         _    _  __   __  ____  ___  ___   __            _    _  __   __  ____  ___  _  _  ___ 
        ( \/\/ )(  ) (  )(_  _)(  ,\(  _) /  \    ___   ( \/\/ )(  ) (  )(_  _)(  ,\( \( )(  _)
         \    / /__\  )(   )(   ) _/ ) _)( () )  (___)   \    / /__\  )(   )(   ) _/ )  (  ) _)
          \/\/ (_)(_)(__) (__) (_)  (___) \___\           \/\/ (_)(_)(__) (__) (_)  (_)\_)(___)
}

PRI StatWaitPxx | lhs, rhs, n, isWaitPeq

  ' WAITPEQ mask                                        Wait until pins all <> 0
  ' WAITPNE mask                                        Wait until any pins == 0
  
  ' WAITPEQ match, mask { , port }
  ' WAITPNE match, mask { , port }
  
  isWaitPeq := ( w == @opcWAITPEQ )
  Token
  lhs := Expr
  if w == @tagEOL
    rhs := lhs
    n := 0
  else
    Want( @symCOMMA )
    rhs := Expr
    if w == @symCOMMA
      Token
      n := Expr
    else
      n := 0

  CheckEol
  if isWaitPeq
    WaitPeq( lhs, rhs, n )
  else
    WaitPne( lhs, rhs, n )

DAT
{
         _    _  _  _  __  __    ___           _    _  ___  _  _  ___  
        ( \/\/ )( )( )(  )(  )  (  _)   ___   ( \/\/ )(  _)( \( )(   \ 
         \    /  )__(  )(  )(__  ) _)  (___)   \    /  ) _) )  (  ) ) )
          \/\/  (_)(_)(__)(____)(___)           \/\/  (___)(_)\_)(___/ 
}

PRI StatWhile

  ' WHILE expr
  ' WEND

  ' REPEAT
  ' WHILE expr

  Token
  if condWant[ condTop ] == @opcUNTIL
    CondPop( condWant[ condTop ] )
    if Expr
      nextPc := condAtPc[ condTop+1 ]
  else
    CondPush( Expr, @opcWEND )
  
PRI StatWend

  ' WHILE expr
  ' WEND

  Token
  CondPop( @opcWEND )
  if conditional[ condTop+1 ]
    nextPc := condAtPc[ condTop+1 ]
       
DAT
{
                                                                                                 
       .d8888b.                         888 d8b 888    d8b                            888          
      d88P  Y88b                        888 Y8P 888    Y8P                            888          
      888    888                        888     888                                   888          
      888         .d88b.  88888b.   .d88888 888 888888 888  .d88b.  88888b.   8888b.  888 .d8888b  
      888        d88""88b 888 "88b d88" 888 888 888    888 d88""88b 888 "88b     "88b 888 88K      
      888    888 888  888 888  888 888  888 888 888    888 888  888 888  888 .d888888 888 "Y8888b. 
      Y88b  d88P Y88..88P 888  888 Y88b 888 888 Y88b.  888 Y88..88P 888  888 888  888 888      X88 
       "Y8888P"   "Y88P"  888  888  "Y88888 888  "Y888 888  "Y88P"  888  888 "Y888888 888  88888P' 
                                                                                                   

}
CON

  COND_MAX = 10

VAR

  byte conditional[ COND_MAX ]
  word condWant[ COND_MAX ]
  long condAtPc[ COND_MAX ]
  byte condTop

PRI CondInit

  conditional[ condTop := 0 ] := true
  condWant[ condTop ] := @opcEND
      
PRI CondPush( n, wantNext )

  if ++condTop => COND_MAX
    Abort @aboNESTING_TOO_DEEP
  conditional[ condTop ] := n and conditional[ condTop-1 ]
  condWant[ condTop ] := wantNext
  condAtPc[ condTop ] := statPc
  
PRI CondPop( gotThis )

  if condTop =< 0
    Abort @aboNESTING_ERROR
  if condWant[ condTop-- ] <> gotThis
    Abort -condWant[ condTop+1 ]
    
DAT
{
             d8888                   d8b                                                   888    
            d88888                   Y8P                                                   888    
           d88P888                                                                         888    
          d88P 888 .d8888b  .d8888b  888  .d88b.  88888b.  88888b.d88b.   .d88b.  88888b.  888888 
         d88P  888 88K      88K      888 d88P"88b 888 "88b 888 "888 "88b d8P  Y8b 888 "88b 888    
        d88P   888 "Y8888b. "Y8888b. 888 888  888 888  888 888  888  888 88888888 888  888 888    
       d8888888888      X88      X88 888 Y88b 888 888  888 888  888  888 Y8b.     888  888 Y88b.  
      d88P     888  88888P'  88888P' 888  "Y88888 888  888 888  888  888  "Y8888  888  888  "Y888 
                                              888                                                 
                                         Y8b d88P                                                 
                                          "Y88P"                                                  

}
PRI Assignment | varPtr, varSize, getValue, putValue, opEquals, op, noOp

  varPtr  := VarRef
  noOp    := varPtr & $8000_0000
  varSize := ( varPtr >> 24 ) & $1F
  varPtr  &= $00FF_FFFF
  if w == @tagEOL
    if noOp
      Abort -@symEQ
  else
    opEquals := w
    op := opcLookupTable[ tokenId - 1 ]
    Token
    putValue := getValue := PeekVar( varPtr, varSize )
    case opEquals
      @symEQ, @symCOLONEQ :
        putValue := Expr
      @symADDEQ,    @symSUBEQ,   @symMPYEQ,    @symDIVEQ, @symMODEQ, @symPCTEQ, {
}     @symANDEQ,    @symOREQ,    @symXOREQ,                                     {
}     @symANDNOTEQ, @symORNOTEQ, @symXORNOTEQ,                                  {
}     @symNANDEQ,   @symNOREQ,   @symXNOREQ,                                    {
}     @symSHLEQ,    @symSHREQ,   @symROLEQ,    @symROREQ, @symASREQ, @symREVEQ, {
}     @symMINEQ,    @symMAXEQ :
        case op
          @symPCT : op := @symMOD   
        putValue := BinaryOp( getValue, op, Expr )
      other :
        Abort -@symEQ
    case varSize & $F
      1 : putValue &= $FF
      2 : putValue &= $FFFF
    if putValue <> getValue
      PokeVar( varPtr, varSize, putValue )

PRI UnaryAssignment

  Abort @aboUNIMPLEMENTED
         
DAT
{

     8888888888                                                     d8b                            
     888                                                            Y8P                            
     888                                                                                           
     8888888    888  888 88888b.  888d888 .d88b.  .d8888b  .d8888b  888  .d88b.  88888b.  .d8888b  
     888        `Y8bd8P' 888 "88b 888P"  d8P  Y8b 88K      88K      888 d88""88b 888 "88b 88K      
     888          X88K   888  888 888    88888888 "Y8888b. "Y8888b. 888 888  888 888  888 "Y8888b. 
     888        .d8""8b. 888 d88P 888    Y8b.          X88      X88 888 Y88..88P 888  888      X88 
     8888888888 888  888 88888P"  888     "Y8888   88888P'  88888P' 888  "Y88P"  888  888  88888P' 
                         888                                                                       
                         888                                                                       
                         888                                                                       

}
PRI PositiveNonZeroNumber

  if ( result := Expr ) =< 0
    Abort @aboINVALID_VALUE
        
PRI PositiveNumber

  if ( result := Expr ) < 0
    Abort @aboINVALID_VALUE
      
PRI Expr

  result := Term(0)
  if debug & DEBUG_SHOWEXPR
    Dbg( String( "EXP" ) )
    Out( "$" )
    Hex( result, 8 )
    Out( "," )
    Out( " " )
    Dec( result )
    Out( $0D )
  
PRI Term( depth ) | op

  if depth > 8
    return Factor

  result := Term( depth+1 )
  repeat
    op := 0
    case depth
      0 : case w
            @opcLOGOR, @opcLOGNOR, @opcLOGXNOR, @opcLOGNXOR         : op := w
      1 : case w
            @opcLOGAND, @opcLOGNAND                     : op := w 
      2 : case w
           @symEQ, @symEQEQ, @opcIS                     : op := @symEQ
           @symNE, @symNOTEQ                            : op := @symNE
           @symLT, @symGT                               : op := w
           @symLE, @symEL                               : op := @symLE
           @symGE, @symEG                               : op := @symGE
         if op
           Token
           return BinaryOp( result, op~, Term( depth+1 ) )
      3 : case w
            @symMIN, @opcMIN, @opcHIGHEST               : op := @symMIN 
            @symMAX, @opcMAX, @opcLOWEST                : op := @symMAX 
      4 : case w
            @symADD, @symSUB                            : op := w 
      5 : case w
            @symMPY, @symDIV                            : op := w 
            @symMOD, @symPCT, @opcMOD                   : op := @symMOD 
      6 : case w
            @symOR, @symXOR, @symNOR, @symXNOR          : op := w
      7 : case w
            @symAND, @symNAND                           : op := w 
      8 : case w
            @symSHL, @symSHR, @symROL, @symROR, @symASR : op := w
    if op
      Token
      result := BinaryOp( result, op, Term( depth+1 ) )
   
  while op

PRI BinaryOp( lhs, op, rhs )
   
  case op
    @symADD     : return lhs +   rhs
    @symSUB     : return lhs -   rhs
    @symMPY     : return lhs *   rhs
    @symDIV     : return lhs /   rhs
    @symMOD     : return lhs //  rhs
    @symAND     : return lhs &   rhs
    @symOR      : return lhs |   rhs
    @symXOR     : return lhs ^   rhs
    @symEQ      : return lhs ==  rhs
    @symNE      : return lhs <>  rhs
    @symLE      : return lhs =<  rhs
    @symLT      : return lhs <   rhs
    @symGE      : return lhs =>  rhs
    @symGT      : return lhs >   rhs
    @symSHL     : return lhs <<  rhs
    @symSHR     : return lhs >>  rhs
    @symROL     : return lhs <-  rhs
    @symROR     : return lhs ->  rhs
    @symASR     : return lhs ~>  rhs
    @symMIN     : return lhs #>  rhs
    @symMAX     : return lhs <#  rhs
    @opcLOGAND  : return lhs and rhs
    @opcLOGOR   : return lhs or  rhs
    @symANDNOT  : return lhs & ! rhs
    @symORNOT   : return lhs | ! rhs
    @symXORNOT  : return lhs ^ ! rhs
    @symNAND    : return !   ( lhs &   rhs )
    @symNOR     : return !   ( lhs |   rhs )
    @symXNOR    : return !   ( lhs ^   rhs )
    @opcLOGNAND : return not ( lhs and rhs )
    @opcLOGNOR  : return not ( lhs or  rhs )
    @opcLOGXOR  : return ( not lhs ) <> not ( rhs )
    @opcLOGXNOR : return ( not lhs ) == not ( rhs )
  Str( op )
  Abort @aboUNIMPLEMENTED

PRI Factor

  if @result > holeMrk
    holeMrk := @result
    
  case w
    @tagNUMBER, @tagTXT :
      result := v
      Token
    @tagVAR, @tagNEW, @tagREG, @opcSPR, @opcBYTE, @opcWORD, @opcLONG, @opcEEPROM, @symINC, @symDEC :
      VarRef
      result := varValue
    @opcTRUE :
      result := true
      Token
    @opcFALSE :
      result := false
      Token
    @opcCLKFREQ :
      result := ClkFreq
      Token
    @opcCHIPVER :
      result := ChipVer
      Token
    @opcROW :
      result := TvGetCurrentRow
      Token
    @opcCOLUMN :
      result := TvGetCurrentColumn
      Token
    @opcINKEY :
      result := InGetAny
      Token
    @symAT :
      Token
      case w
        @tagVAR, @tagNEW :
          result := ApplyVarIndex( CreateVar, GetVarSizeFromType( varType ) )
        @tagTXT :
          result := v
          Token
        @tagNUMBER :
          ' Returns address of line number ( for GOTO * )
          result := LineNumber
        other :
          Abort -@tagVAR
    @symLPARA :
      Token
      result := Expr
      Want( @symRPARA )
    @opcLOGNOT :
      Token
      result := not Term(2) ' Not factor ! Propeller precedence is a bit odd
    @symADD, @symSUB, @symNOT, @symBIT, @symSXB, @symSXW, @symABS, @symSQR, @symABS :
      result := FactorUnary
    @opcABS, @opcSQR, @opcMEM, @opcLSB, @opcMSB, @opcLSW, @opcMSW :
      result := FactorFunction( 1 )
    @opxVAR :
      result := FactorFunction( 2 )
    @opcIF :
      ' var := IF expr THEN trueExpr ELSE falseExpr
      Token
      if Expr
        Want( @opcTHEN )
        result := Expr
        Want( @opcELSE )
        Expr
      else
        Want( @opcTHEN )
        Expr
        Want( @opcELSE )
        result := Expr
    other :
      Abort @aboFACTOR_EXPECTED

PRI FactorUnary | op

  op := w
  Token
  result := Factor
  case op
    @symADD  :
    @symSUB  : -   result
    @symNOT  : !   result
    @symBIT  : |<  result
    @symSXB  : ~   result
    @symSXW  : ~~  result
    @symABS  : ||  result
    @symSQR  : ^^  result
    other   : Abort @aboUNIMPLEMENTED
      
PRI FactorFunction( argCount ) | op, arg[3]

  op := w
  Token
  Want( @symLPARA )
  result := arg[ --argCount ] := Expr
  repeat while --argCount > 0
    Want( @symCOMMA )
    arg[ argCount ] := Expr
  Want( @symRPARA )
  case op
    @opcABS  : ||  result
    @opcSQR  : ^^  result
    @opxVAR  : result := VarFunc( arg[0], arg[1] )
    @opcMEM  : result := MemInfo( result )
    @opcLSB  : result &= $FF
    @opcMSB  : result := ( result >> 8 ) & $FF
    @opcLSW  : result &= $FFFF
    @opcMSW  : result >>= 16
    other    : Abort @aboUNIMPLEMENTED

DAT
{

     888     888                    888    888                        888 888 d8b                   
     888     888                    888    888                        888 888 Y8P                   
     888     888                    888    888                        888 888                       
     Y88b   d88P 8888b.  888d888    8888888888  8888b.  88888b.   .d88888 888 888 88888b.   .d88b.  
      Y88b d88P     "88b 888P"      888    888     "88b 888 "88b d88" 888 888 888 888 "88b d88P"88b 
       Y88o88P  .d888888 888        888    888 .d888888 888  888 888  888 888 888 888  888 888  888 
        Y888P   888  888 888        888    888 888  888 888  888 Y88b 888 888 888 888  888 Y88b 888 
         Y8P    "Y888888 888        888    888 "Y888888 888  888  "Y88888 888 888 888  888  "Y88888 
                                                                                                888 
                                                                                           Y8b d88P 
                                                                                            "Y88P"  

}
PRI VarRef | preInc, anyOps, varPtr, varSize, getValue, putValue

  anyOps := preInc := 0
    
  repeat while ( w == @symINC ) or ( w == @symDEC )
    anyOps := true
    if w == @symINC
      preInc++
    else
      preInc--
    Token

  case w   
    @tagVAR, @tagNEW :
      varSize := GetVarSizeFromType( varType )
      varPtr := ApplyVarIndex( CreateVar, varSize )
      varSize := TypeModifier( @varPtr, varSize )
    @tagREG :
      varPtr := v
      varSize := 0
      Token
    @opcBYTE, @opcWORD, @opcLONG, @opcSPR :
      case w
        @opcSPR  : varSize := 0
        @opcBYTE : varSize := 1
        @opcWORD : varSize := 2
        @opcLONG : varSize := 4
      varPtr := ApplyVarIndex( 0, 1 )
    @opcEEPROM :
      varPtr := ApplyVarIndex( 0, 1 )
      ' Determine the size of EEPROM[] if there's no modifier then we get back $15 which we know does
      ' not make sense so we know there was no modifier so we treat it as a byte. If there is a modifier
      ' the we'll get back $11, $12 or $14 and that's okay.
      varSize := $10 + TypeModifier( @varPtr, 5 )
      if varSize == $15
        varSize := $11
    other :
      Abort -@tagVAR

  if w == @symDOT
    Abort @aboMODIFIER_ERROR
 
  putValue := ( varValue := ( getValue := PeekVar( varPtr, varSize ) )+ preInc )
      
  if w == @symSXB
    Token
    anyOps := true
    putValue := 0
  else
    if w == @symSXW
      Token
      anyOps := true
      putValue := -1
      
  repeat while ( w == @symINC ) or ( w == @symDEC )
    anyOps := true
    if w == @symINC
      putValue++
    else
      putValue--
    Token

  if anyOps
    case varSize and $F
      1 : putValue &= $FF
      2 : putValue &= $FFFF
    if putValue <> getValue      
      PokeVar( varPtr, varSize, putValue ) 
  else
    varPtr |= $8000_0000

  if debug & DEBUG_SHOWVARDEF
    OnNewLine
    Str( String( "#VAR " ) )
    Dec( getValue )
    if anyOps
      Out( " " )
      Dec( varValue )
      Out( " " )
      Dec( putValue )
    Out( $0D )
      
  result := varSize << 24 | varPtr

PRI ApplyVarIndex( nPtr, nSize )

  Token
  if w == @symLPARA 
    Token
    nPtr += PositiveNumber * nSize
    Want( @symRPARA )
  else
    if nPtr == 0
      if w <> @symLBRACKET
        Abort -@symLBRACKET 
    repeat while w == @symLBRACKET
      Token
      nPtr += PositiveNumber * nSize
      Want( @symRBRACKET )
      nSize := 1

  result := nPtr

PRI TypeModifier( nAtPtr, nSize )

  ' .LSB
  ' .MSB
  ' .LSW
  ' .MSW

  ' .BYTE
  ' .WORD
  ' .LONG
  
  repeat while w == @symDOT
    Token
    case w
    
      @opcBYTE, @opcLSB :
        nSize := 1

      @opcWORD, @opcLSW :
        if nSize < 2
          Abort @aboMODIFIER_ERROR
        nSize := 2

      @opcLONG :
        if nSize < 4
          Abort @aboMODIFIER_ERROR
        nSize := 4
        
      @opcMSB :
        if nSize < 2
          Abort @aboMODIFIER_ERROR
        nSize := 1
        long[ nAtPtr ]++

      @opcMSW :
        if nSize < 4
          Abort @aboMODIFIER_ERROR
        nSize := 2
        long[ nAtPtr ] += 2
        
      other :
        Abort @aboMODIFIER_ERROR

    Token

  result := nSize
  
        
PRI PeekVar( nPtr, nSize )

  if @result > holeMrk
    holeMrk := @result

  case nSize
  
    0   : result := SPR[ nPtr & $F ]
    
    1   : result := byte[ nPtr ]
    2   : result := word[ nPtr ]
    4   : result := long[ nPtr ]
    
    $11 : result := i2c.ReadByte( nPtr )
    $12 : result := i2c.ReadWord( nPtr )
    $14 : result := i2c.ReadLong( nPtr )
        
PRI PokeVar( nPtr, nSize, n )

  case nSize
  
    0   : SPR[ nPtr & $F ]  := n
    
    1   : byte[ nPtr ] := n
    2   : word[ nPtr ] := n
    4   : long[ nPtr ] := n
    
    $11 : if i2c.ReadByte( nPtr ) <> n
            i2c.WriteByte( nPtr, n )
    $12 : if i2c.ReadWord( nPtr ) <> n
            i2c.WriteWord( nPtr, n )
    $14 : if i2c.ReadLong( nPtr ) <> n
            i2c.WriteLong( nPtr, n )
      
DAT
{

           .d8888b.           888       88888888888       888                                 
          d88P  Y88b          888           888           888                                 
          888    888          888           888           888                                 
          888         .d88b.  888888        888   .d88b.  888  888  .d88b.  88888b.  .d8888b  
          888  88888 d8P  Y8b 888           888  d88""88b 888 .88P d8P  Y8b 888 "88b 88K      
          888    888 88888888 888           888  888  888 888888K  88888888 888  888 "Y8888b. 
          Y88b  d88P Y8b.     Y88b.         888  Y88..88P 888 "88b Y8b.     888  888      X88 
           "Y8888P88  "Y8888   "Y888        888   "Y88P"  888  888  "Y8888  888  888  88888P' 


}
VAR

  long w
  long v
  byte varType
  long varValue
  byte tokenId

  long pushedToken
  long pushedPc
  
PRI TokenPushState

  pushedToken   := w
  pushedPc      := pc
  
PRI TokenPopState

  w       := pushedToken
  pc      := pushedPc
  
PRI Token

  repeat
    case result := SingleToken
      @tagSPC, @tagBIN, @tagHEX :
        result := false
      @tagREM :
        repeat while ( result := SingleToken ) <> @tagEOL
  until result
          
PRI SingleToken

  case result := w := opcLookupTable[ tokenId := byte[ lastPc := pc++ ] ]
    @tagBYTE, @tagCHAR :
      w := @tagNUMBER
      v := byte[ pc++ ]
    @tagWORD :
      w := @tagNUMBER
      v := byte[ pc++ ] << 8 | byte[ pc++ ]
    @tagTRIP :
      w := @tagNUMBER
      v := byte[ pc++ ] << 16 | byte[ pc++ ] << 8 | byte[ pc++ ]
    @tagNUMBER :
      v := byte[ pc++ ] << 24 | byte[ pc++ ] << 16 | byte[ pc++ ] << 8 | byte[ pc++ ]
    @tagVAR, @tagNEW :
      v := pc
      pc += 2
      repeat while ( ( varType := byte[ pc++ ] ) & $80 )
    @tagREG :
      v := byte[ pc++ ]
    @tagTXT :
      v := pc
      repeat while ( byte[ pc++ ] & $80 )
    @tagREM :
      repeat while ( result := byte[ pc++ ] ) <> @tagEOL
    @tagSPC :
      v := byte[ pc++ ]
    @opcGOTO, @opcGOSUB :
      v := byte[ pc++ ] << 8 | byte[ pc++ ]
    @tagEOF :
      Abort @aboFELL_OFF_END

  if debug & constant( DEBUG_SHOWTOKEN | DEBUG_ALLTOKENS )
    if debug & DEBUG_SHOWTOKEN
      Dbg( String( "TOK" ) )
      ListToken( lastPc, w )
    else
      Str( w )
      
DAT
{

            888      d8b                      8888888888     888 d8b 888                    
            888      Y8P                      888            888 Y8P 888                    
            888                               888            888     888                    
            888      888 88888b.   .d88b.     8888888    .d88888 888 888888 .d88b.  888d888 
            888      888 888 "88b d8P  Y8b    888       d88" 888 888 888   d88""88b 888P"   
            888      888 888  888 88888888    888       888  888 888 888   888  888 888     
            888      888 888  888 Y8b.        888       Y88b 888 888 Y88b. Y88..88P 888     
            88888888 888 888  888  "Y8888     8888888888 "Y88888 888  "Y888 "Y88P"  888     

}

VAR

  long rnd
  
PRI Type( strPtr ) | n 

  if rnd == 0
    rnd := CNT
    
  OnNewLine
  Out( ">" )
  repeat StrSize( strPtr )
    if DEMO_MODE
      WaitCnt( CLKFREQ / 1000 * ( 400 + ( ? rnd // 200 ) ) + CNT )
    Out( byte[ strPtr++ ] )
  Out( $0D )

PRI BuildCommandLine | n

  repeat
    Out( ">" )
    repeat
      if rxBreak~ or kbBreak~
        Str( String( "<BREAK>" ) ) '@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        RxFlush
        KbFlush
      if ( n := InGetAny ) => 0
        Out( n )
    until n == $0D

DAT
{

         888      d8b                      8888888b.                                            
         888      Y8P                      888   Y88b                                           
         888                               888    888                                           
         888      888 88888b.   .d88b.     888   d88P 8888b.  888d888 .d8888b   .d88b.  888d888 
         888      888 888 "88b d8P  Y8b    8888888P"     "88b 888P"   88K      d8P  Y8b 888P"   
         888      888 888  888 88888888    888       .d888888 888     "Y8888b. 88888888 888     
         888      888 888  888 Y8b.        888       888  888 888          X88 Y8b.     888     
         88888888 888 888  888  "Y8888     888       "Y888888 888      88888P'  "Y8888  888     
                                                                                                
}
DAT
DAT
{                                                                                              


          8888888888                                      888    888    d8b                   
          888                                             888    888    Y8P                   
          888                                             888    888                          
          8888888  .d88b.  888d888 88888b.d88b.   8888b.  888888 888888 888 88888b.   .d88b.  
          888     d88""88b 888P"   888 "888 "88b     "88b 888    888    888 888 "88b d88P"88b 
          888     888  888 888     888  888  888 .d888888 888    888    888 888  888 888  888 
          888     Y88..88P 888     888  888  888 888  888 Y88b.  Y88b.  888 888  888 Y88b 888 
          888      "Y88P"  888     888  888  888 "Y888888  "Y888  "Y888 888 888  888  "Y88888 
                                                                                          888 
                                                                                     Y8b d88P 
                                                                                      "Y88P"  
}
VAR

  byte numberRadix
  byte numberWidth

PRI OnNewLine

  if notHadCrLf
    Out( $0D )

PRI Mhz( n )

  n := CLKFREQ / 500_000
  Dec( ( n >> 1 ) + ( n & 1 ) )

PRI Dkb( n )

  if n
    if ( n & 1023 )
      Dec( n )
      if n => 1024
        Str( String( " ( " ) )
        if n & 512
          Out( "<" )
          n += 512
        else
          Out( ">" )
        Out( " " )
        Dec( n >> 10 )
        Str( String( "K )" ) )
    else
      Dec( n >> 10 )
      Out( "K" )
  else
    Str( String( "None" ) )
    
PRI Dec( n )

  if fileHandle => 0
    OutNumberFormat( n, 10, 0 )
  
PRI Bin( n, s )

  if fileHandle => 0
    OutNumberFormat( n, 2, s )
  
PRI Hex( n, s )

  if fileHandle => 0
    OutNumberFormat( n, 16, s )

PRI Num( n, s )

  if fileHandle => 0
    OutNumberFormat( n, 10, s )
    
PUB OutNumberFormat( n, radix, width )

  numberRadix := radix
  numberWidth := width
  OutNumber(n)

PUB OutNumber( n ) |  digits, k

    if n == 0 
      repeat numberWidth #> 1
        Out("0")
    else

      case numberRadix

        2  : OutRadixNumber(n,31,$1,1,32)
        4  : OutRadixNumber(n,30,$3,2,16)
        8  : OutRadixNumber(n,30,$7,3,11)
        16 : OutRadixNumber(n,28,$F,4,8)

        other : k := 1_000_000_000
                digits := 11
                if n < 0
                  Out("-")
                  n := -n
                  digits--
                repeat while k > n
                  k /= 10
                  digits--
                repeat while numberWidth => digits++
                  Out("0")
                repeat while k <> 0
                  OutDigit( ( n / k ) // 10 )
                  k /= 10

  numberRadix := 10
  
PUB OutRadixNumber(n,shift,mask,decr,digits)

  repeat while ( n >> shift ) == 0
    shift -= decr
    digits--
  repeat while numberWidth > digits++
    Out("0")
  repeat while shift => 0
    OutDigit( ( n >> shift ) & mask )
    shift -= decr

PUB OutDigit( n )

  if ( n += "0" ) > "9"
    n := n - "9" + "A" - 1
  Out( n )

PRI StrChoice( n , nCount )

  repeat nCount
    n += StrSize(n)+1
    
  Str( n )
  
PRI Str( n )

  if fileHandle => 0
    repeat StrSize( n )
      Out( byte[ n++ ] )

DAT
{

     8888888888 d8b 888             888    888                        888 888 d8b                   
     888        Y8P 888             888    888                        888 888 Y8P                   
     888            888             888    888                        888 888                       
     8888888    888 888  .d88b.     8888888888  8888b.  88888b.   .d88888 888 888 88888b.   .d88b.  
     888        888 888 d8P  Y8b    888    888     "88b 888 "88b d88" 888 888 888 888 "88b d88P"88b 
     888        888 888 88888888    888    888 .d888888 888  888 888  888 888 888 888  888 888  888 
     888        888 888 Y8b.        888    888 888  888 888  888 Y88b 888 888 888 888  888 Y88b 888 
     888        888 888  "Y8888     888    888 "Y888888 888  888  "Y88888 888 888 888  888  "Y88888 
                                                                                                888 
                                                                                           Y8b d88P 
                                                                                            "Y88P"  
}
DAT
{
        File Handling as a bit of a misnomer at present; it is really serial port routing because that
        is all that it handles. A pin may be opened for serial input or output, only one pin may be used
        for serial at a time and only ne pin may be used with any file handle. To use the same pin in a
        different way requires the file to be closed.

        The console is a special case ( file handle #0 ). Everything sent to the TV is also sent up the
        pin open on #0 and everything coming in on #0 is merged with keyboard data. This mode is set
        when first powered up and when the program stops. The console is automatically disconnected when
        the program does something which makes the connection invalid or incompatible with what has been
        specified.

        In the fullness of time, file handling will also include redirecting output to real file streams
        such as SD Card or Eeprom and allow input from the same.
}
CON

  FILE_MAX        = 7           ' Must be power of 2 minus 1, 31 maximum ( ie 1, 3, 7, 15, 31 )
  
  FILE_MODE_CLOSED     = %000
  FILE_MODE_INPUT      = %001
  FILE_MODE_OUTPUT     = %010
  FILE_MODE_OPEN       = %011
  FILE_MODE_CONSOLE    = %111
  
  PINS_NOT_OUTPUT = |< RX_PROP_PIN + |< KB_DAT_PIN + |< KB_CLK_PIN + ( %111 << TV_PIN )
  PINS_NOT_INPUT  = |< TX_PROP_PIN + |< KB_DAT_PIN + |< KB_CLK_PIN + ( %111 << TV_PIN )
  
VAR

  long fileHandle
  
  byte fileMode       [ FILE_MAX + 1 ]
  byte filePinNumber  [ FILE_MAX + 1 ]
  long fileBitTime    [ FILE_MAX + 1 ]
  byte fileParityType [ FILE_MAX + 1 ]
  byte fileDataBits   [ FILE_MAX + 1 ]
  byte fileStopBits   [ FILE_MAX + 1 ]
  
  byte consoleInitialised
  byte notHadCrLf
  
PRI Out( n )

  if fileHandle => 0
    if fileHandle == 0
      tv.Out( n )
      notHadCrLf := ( n <> $0D )
      if fileMode[ 0 ] & FILE_MODE_OUTPUT
        TxOut( n )
    else
      if not ( fileMode[ fileHandle ] & FILE_MODE_OUTPUT )
        Abort @aboBAD_FILE_MODE
      TxOut( n )

PRI FileOpenConsole

  fileHandle := 0

  if consoleInitialised~~ == 0
  
    TxInit

    if TX_PIN => 0
      FileOpen( TX_PIN, BAUD_RATE, PARITY_NONE, DATA_8, STOP_1, FILE_MODE_CONSOLE, fileHandle ) 
      TxOut( $0D )

    if RX_PIN => 0
      RxInit

PRI FileOpen( argPinNumber, argBaudRate, argParityType, argDataBits, argStopBits, argMode, f ) | n, txInvert

  if argMode <> FILE_MODE_CONSOLE
    if argMode & FILE_MODE_INPUT
      if PINS_NOT_INPUT & ( |< argPinNumber )
        Abort @aboPIN_IN_USE
    else
      if PINS_NOT_OUTPUT & ( |< argPinNumber )
        Abort @aboPIN_IN_USE

  if fileMode[f] & FILE_MODE_OPEN
    if fileMode[ n ] == FILE_MODE_CONSOLE
      FileClose(n)
    else
      Abort @aboFILE_OPEN
    
  repeat n from 0 TO FILE_MAX
    if ( fileMode[n] & FILE_MODE_OPEN ) and ( filePinNumber[n] == argPinNumber )
      if fileMode[ n ] == FILE_MODE_CONSOLE
        FileClose(n)
      else
        Abort @aboPIN_IN_USE
    if ( argMode & FILE_MODE_INPUT ) and ( fileMode[n] & FILE_MODE_INPUT )
      if fileMode[ n ] == FILE_MODE_CONSOLE
        FileClose(n)
      else
        Abort @aboINPUT_IN_USE

  fileMode[f]       := argMode
  filePinNumber[f]  := argPinNumber    
  fileBitTime[f]    := FileOpenSetDefault( CLKFREQ / || argBaudRate, fileBitTime[f],    CLKFREQ / BAUD_RATE ) 
  fileParityType[f] := FileOpenSetDefault( argParityType,            fileParityType[f], PARITY_NONE ) 
  fileDataBits[f]   := FileOpenSetDefault( argDataBits,              fileDataBits[f],   DATA_8 ) 
  fileStopBits[f]   := FileOpenSetDefault( argStopBits,              fileStopBits[f],   STOP_1 ) 

  ' Auto-limit to 19200 baud if necessary
       
  if CLKFREQ =< 96_000_000 
    fileBitTime[f] #>= txBitTimeAt19200Baud

  txInvert := ( argPinNumber => 28 ) ^ ( argBaudRate < 0 )
    
  TxPut( TX_CMD_OPEN | f, txInvert )

  if argMode == FILE_MODE_CONSOLE
    rxBitTime := fileBitTime[f]
    rxInvert  := txInvert
  
PRI FileOpenSetDefault( requested, current, default )

  if ( result := requested ) == 0
    if ( result := current ) == 0
      result := default
  
PRI FileCloseAll | f

  repeat f from 0 to FILE_MAX
    if fileMode[ f ] <> FILE_MODE_CONSOLE
      FileClose( f )
    
PRI FileClose( f )

  if fileMode[ f ] & FILE_MODE_OUTPUT
    TxPut( TX_CMD_CLOSE | f, 0 )
    repeat until TxEmpty
  fileMode[ f ] := FILE_MODE_CLOSED

PRI FileNumber

  result := PositiveNumber & FILE_MAX

PRI ListFiles( n ) | f, nRepeat

  n &= FILE_MODE_OPEN

  repeat f from 0 to FILE_MAX
    if ( fileMode[f] & FILE_MODE_OPEN ) == n
      if fileMode[f] == FILE_MODE_CONSOLE
        ListThisFile( f, RX_PIN, FILE_MODE_INPUT )
      ListThisFile( f, filePinNumber[f] , fileMode[f] )
      result++
      
  if result == 0
    Str( String( "None" ) )

PRI ListThisFile( f, nPin, nMode )

  Dec( f )
  Out( " " )
  if nMode & FILE_MODE_OUTPUT
    Out( ">" )
  else
    Out( "<" )
  Out( " " )
  Dec( nPin )
  Out( "," )
  Dec( CLKFREQ / fileBitTime[f] )
  Out( "," )
  Out( LookupZ( fileParityType[f] : "?NOE01" ) )
  Out( "," )
  Dec( fileDataBits[f] )
  Out( "," )
  Dec( fileStopBits[f] )
  if fileMode[f] == FILE_MODE_CONSOLE
    Str( String( " Console" ) )
  Out( $0D )
             
DAT
{

         88888888888 Y88b   d88P    888    888                        888 888                  
             888      Y88b d88P     888    888                        888 888                  
             888       Y88o88P      888    888                        888 888                  
             888        Y888P       8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
             888        d888b       888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
             888       d88888b      888    888 .d888888 888  888 888  888 888 88888888 888     
             888      d88P Y88b     888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
             888     d88P   Y88b    888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     
                                                                                               
}
CON

  TX_BUFFER_MASK = $3F

  TX_STACK_SIZE = 25

  PARITY_NONE   = 1
  PARITY_ODD    = 2
  PARITY_EVEN   = 3
  PARITY_ZERO   = 4
  PARITY_ONE    = 5
  
  DATA_7        = 7
  DATA_8        = 8

  STOP_1        = 1
  STOP_2        = 2

  TX_CMD_TXBYTE = %000_00000
  TX_CMD_OPEN   = %001_00000
  TX_CMD_CLOSE  = %010_00000
  TX_CMD_LOW    = %011_00000
  TX_CMD_HIGH   = %100_00000
  TX_CMD_TOGGLE = %101_00000
  TX_CMD_BREAK  = %110_00000
  TX_CMD_PAUSE  = %111_00000
    
VAR

  byte txCogNumber
  
  byte txPutPtr
  byte txGetPtr
  byte txBuffer       [ TX_BUFFER_MASK+2 ]
  byte txFileNum      [ TX_BUFFER_MASK+2 ]
  
  long txStack        [ TX_STACK_SIZE ]

  long txBitTimeAt19200Baud
  
PRI TxVersion

  result := String( "TX" )
    
PRI TxInit

  if txCogNumber
    CogStop( txCogNumber~ - 1 )

  txGetPtr := txPutPtr

  txBitTimeAt19200Baud := CLKFREQ / 19200
     
  CogSetInfo( txCogNumber := CogNew( TxHandler, CogNewStack(@txStack,TX_STACK_SIZE) ) , TxVersion )
  txCogNumber++
  
PRI TxEmpty

  result := ( txPutPtr == txGetPtr )
  
PRI TxOut( n )

  TxPut( fileHandle, n )
  if n == $0D
    TxPut( fileHandle, $0A )

PRI TxPut( f, n ) | txNxtPtr

  txNxtPtr := ( txPutPtr+1 ) & TX_BUFFER_MASK
  repeat while txNxtPtr == txGetPtr
  txFileNum[ txPutPtr ] := f
  txBuffer[ txPutPtr ] := n
  txPutPtr := txNxtPtr
  
PRI TxHandler | f, n, txPin, timeout, txBitTime, txParityType, txDataBits, txStopBits

  repeat

    repeat while txGetPtr == txPutPtr

    case ( f := txFileNum[ txGetPtr ] ) & %111_00000

      TX_CMD_TXBYTE :
       
        ' Get all the required data from the buffer ...
        
        txPin        := filePinNumber[f]
        txBitTime    := fileBitTime[f]
        txParityType := fileParityType[f]
        txDataBits   := fileDataBits[f]
        txStopBits   := fileStopBits[f]
        n            := txBuffer[ txGetPtr ]
       
        ' ... before allowing something else to overwrite it
        
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK
       
        ' Determine the data bits to send
        
        n := ( n ^ $FF ) & ( ( |< txDataBits ) - 1 )
       
        ' Add in any parity bits

        if txParityType <> PARITY_NONE
          txStopBits++
          case txParityType
            PARITY_ODD  : result := BitCount( n ) ^ 1
            PARITY_EVEN : result := BitCount( n )
            PARITY_ZERO :
            PARITY_ONE  : result := 1
            other       : txStopBits--
          if result & 1
            n |= |< txDataBits
           
        ' Set the start bit, invert bit stream as required, and pre-adjust for banging out
        
        n := ( ( n << 1 | 1 ) ^ ( OUTA[ txPin ] <> 0 ) ) << 1
       
        txDataBits += txStopBits + 2
       
        ' Bit-bang it out
        
        timeout := CNT
        repeat txDataBits
          OUTA[ txPin ] := ( n ~>= 1 )
          WaitCnt( timeout += txBitTime )

      TX_CMD_OPEN :

        f &= $1F
        txPin     := filePinNumber[ f ]
        txBitTime := fileBitTime[ f ]
        n         := txBuffer[ txGetPtr ] & 1

        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK
               
        result := ( ( OUTA[ txPin ] <> n ) or ( DIRA[ txPin ] <> 1 ) )

        OUTA[ txPin ] := n
        DIRA[ txPin ] := 1
        
        if result
          WaitCnt( ( txBitTime << 4 ) + CNT )

      TX_CMD_CLOSE :            ' CLOSE
        
        DIRA[ filePinNumber[ f & $7F ] ] := 0
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_LOW :              ' LOW

        OUTA[ filePinNumber[ f & $1F ] ] := 0
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_HIGH :             ' HIGH

        OUTA[ filePinNumber[ f & $1F ] ] := 1
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_TOGGLE :           ' TOGGLE

        OUTA[ filePinNumber[ f & $1F ] ] ^= 1
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

      TX_CMD_BREAK :            ' BREAK ( n x 1mS )

        txPin    := filePinNumber[ f & $1F ]
        n        := txBuffer[ txGetPtr ]
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

        OUTA[ txPin ] ^= 1
        if n
          WaitCnt( CLKFREQ / 1000 * n + CNT )
        OUTA[ txPin ] ^= 1
 
      TX_CMD_PAUSE :           ' PAUSE ( n x mS )

        n        := txBuffer[ txGetPtr ]
        txGetPtr := ( txGetPtr + 1 ) & TX_BUFFER_MASK

        if n
          WaitCnt( CLKFREQ / 1000 * n + CNT )

PRI BitCount( n )

  repeat while n <> 0
    result += ( n & 1 )
    n >>= 1
           
DAT
{

          8888888b.  Y88b   d88P    888    888                        888 888                  
          888   Y88b  Y88b d88P     888    888                        888 888                  
          888    888   Y88o88P      888    888                        888 888                  
          888   d88P    Y888P       8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
          8888888P"     d888b       888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
          888 T88b     d88888b      888    888 .d888888 888  888 888  888 888 88888888 888     
          888  T88b   d88P Y88b     888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
          888   T88b d88P   Y88b    888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}
CON

  RX_BUFFER_MASK = $3F

  RX_STACK_SIZE = 20
  
VAR

  byte rxPutPtr
  byte rxGetPtr
  byte rxBuffer       [ RX_BUFFER_MASK+2 ]
  
  long rxStack        [ RX_STACK_SIZE ]

  long rxBitTime
  byte rxInvert
  byte rxBreak

PRI RxVersion

  result := String( "RX" )
    
PRI RxInit

  CogSetInfo( CogNew( RxHandler, CogNewStack(@rxStack,RX_STACK_SIZE) ) , RxVersion )  

PRI RxAnyAvailable

  result := rxGetPtr <> rxPutPtr

PRI RxGetAny

  if rxGetPtr == rxPutPtr
    result := -1
  else
    result := RxGet

PRI RxGet

  repeat while rxGetPtr == rxPutPtr 
  result := rxBuffer[ rxGetPtr ]
  rxGetPtr := ( rxGetPtr + 1 ) & RX_BUFFER_MASK

PRI RxFlush

  repeat until RxGetAny < 0
  
PRI RxHandler | n, timeout, rxNxtPtr, rxStopBit

  DIRA[ RX_PIN ] := 0

  repeat

    if rxInvert
      WaitPeq( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      WaitPne( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      timeout := CNT + ( rxbitTime >> 1 )
    else
      WaitPne( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      WaitPeq( constant( |< RX_PIN ), constant( |< RX_PIN ), 0)
      timeout := CNT + ( rxbitTime >> 1 )
    
    repeat 8
      WaitCnt( timeout += rxBitTime )
      n := ( n << 1 ) | INA[ RX_PIN]

    WaitCnt( timeout += rxBitTime )

    if ( n := ( n >< 8 ) ^ rxInvert ^ $FF ) == 0
      rxStopBit := INA[ RX_PIN] ^ rxInvert & 1
    else
      rxStopBit := false
      
    if rxStopBit
      rxBreak := true
    else
      rxNxtPtr := ( rxPutPtr+1 ) & RX_BUFFER_MASK
      repeat while rxNxtPtr == rxGetPtr
      rxBuffer[ rxPutPtr ] := n
      rxPutPtr := rxNxtPtr

DAT
{

          888    d8P  888888b.      888    888                        888 888                  
          888   d8P   888  "88b     888    888                        888 888                  
          888  d8P    888  .88P     888    888                        888 888                  
          888d88K     8888888K.     8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
          8888888b    888  "Y88b    888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
          888  Y88b   888    888    888    888 .d888888 888  888 888  888 888 88888888 888     
          888   Y88b  888   d88P    888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
          888    Y88b 8888888P"     888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}
VAR

  byte kbBreak

PRI KbInit

  CogNewStack( 0, 0 )
  CogSetInfo( kb.start( KB_DAT_PIN, KB_CLK_PIN ) - 1, kb.Version )

PRI KbAnyAvailable_DO_NOT_USE

  result := -1  '  @@@@@@@@@@@@@@@@@@@@@@@@@@@
  
PRI KbGetAny

  if ( result := kb.key ) == 0
    result := -1

PRI KbGet

  repeat Until ( result := kb.key ) <> 0

PRI KbFlush

  repeat while kb.key <> 0

DAT
{

           8888888 888b    888    888    888                        888 888                  
             888   8888b   888    888    888                        888 888                  
             888   88888b  888    888    888                        888 888                  
             888   888Y88b 888    8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
             888   888 Y88b888    888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
             888   888  Y88888    888    888 .d888888 888  888 888  888 888 88888888 888     
             888   888   Y8888    888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
           8888888 888    Y888    888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}

PRI InGetAny

  if ( result := RxGetAny ) < 0
    result := KbGetAny

DAT
{

         88888888888 888     888    888    888                        888 888                  
             888     888     888    888    888                        888 888                  
             888     888     888    888    888                        888 888                  
             888     Y88b   d88P    8888888888  8888b.  88888b.   .d88888 888  .d88b.  888d888 
             888      Y88b d88P     888    888     "88b 888 "88b d88" 888 888 d8P  Y8b 888P"   
             888       Y88o88P      888    888 .d888888 888  888 888  888 888 88888888 888     
             888        Y888P       888    888 888  888 888  888 Y88b 888 888 Y8b.     888     
             888         Y8P        888    888 "Y888888 888  888  "Y88888 888  "Y8888  888     

}

PRI TvMode( n )

  tv.Open( TV_PIN, n )

PRI TvCls

  tv.Cls
    
PRI TvAt( argRow, argColumn )

  tv.At( argRow, argColumn )

PRI TvAtRow( argRow )

  tv.AtRow( argRow )

PRI TvColor( n )

  tv.SetColour( n )

PRI TvGetCurrentRow

  result := tv.GetCurrentRow
  
PRI TvGetCurrentColumn

  result := tv.GetCurrentColumn
         
DAT
{

     .d8888b.                       88888888888                       888      d8b                   
    d88P  Y88b                          888                           888      Y8P                   
    888    888                          888                           888                            
    888         .d88b.   .d88b.         888  888d888 8888b.   .d8888b 888  888 888 88888b.   .d88b.  
    888        d88""88b d88P"88b        888  888P"      "88b d88P"    888 .88P 888 888 "88b d88P"88b 
    888    888 888  888 888  888        888  888    .d888888 888      888888K  888 888  888 888  888 
    Y88b  d88P Y88..88P Y88b 888        888  888    888  888 Y88b.    888 "88b 888 888  888 Y88b 888 
     "Y8888P"   "Y88P"   "Y88888        888  888    "Y888888  "Y8888P 888  888 888 888  888  "Y88888 
                             888                                                                 888 
                        Y8b d88P                                                            Y8b d88P 
                         "Y88P"                                                              "Y88P"  
}
  
VAR

  word cogLastStkPtr
  word cogLastStkSiz

  word cogInfoStkPtr[8]
  word cogInfoStkSiz[8]
  word cogInfoTxtPtr[8]
  
PRI CogNewStack( argStackPtr, argStackSize )

  cogLastStkPtr := result := argStackPtr

  if argStackSize
    cogLastStkSiz := argStackSize
    repeat argStackSize
      long[ argStackPtr ] := MAGIC_NUMBER
      argStackPtr += 4
  else
    cogLastStkSiz := argStackSize
    ' fill Main stack
    argStackPtr := argStackPtr + constant( 1000 << 2 ) & ! 3
    repeat while argStackPtr < CODE_BASE
      ' long[ argStackPtr ] := MAGIC_NUMBER
      argStackPtr += 4

PRI CogSetInfo( argCogNumber, argCogTxtPtr )

  if ( result := argCogNumber ) => 0
    cogInfoStkPtr[ argCogNumber ] := cogLastStkPtr
    cogInfoStkSiz[ argCogNumber ] := cogLastStkSiz
    cogInfoTxtPtr[ argCogNumber ] := argCogTxtPtr

PRI CogStackUsed( argCogNumber ) | nPtr

  nPtr := cogInfoStkPtr[ argCogNumber ]
  repeat while long[ nPtr ] <>  MAGIC_NUMBER and result =< cogInfoStkSiz[ argCogNumber ]
    result++
    nPtr += 4
  
PRI ListCogs  | n

  repeat n from 0 to 7
    Dec( n )
    Out( " " )
    if cogInfoTxtPtr[n] 
      if cogInfoStkPtr[n] 
        Hex( cogInfoStkPtr[n], 4 )
        Out( " " )
        if cogInfoStkSiz[n] 
          Dec( cogInfoStkSiz[n] )
          Out( " " ) 
          Dec( cogStackUsed(n) )
        else
          Str( String( "- -" ) )
      else
        Str( String( "None - -" ) )
      Out( " " ) 
      Str( cogInfoTxtPtr[n] ) 
    else
      Str( String( "Free" ) )
    Out( $0D )
    
DAT
{

                   .d8888b.                888             8888888          d8b 888    
                  d88P  Y88b               888               888            Y8P 888    
                  888    888               888               888                888    
                  888         .d88b.   .d88888  .d88b.       888   88888b.  888 888888 
                  888        d88""88b d88" 888 d8P  Y8b      888   888 "88b 888 888    
                  888    888 888  888 888  888 88888888      888   888  888 888 888    
                  Y88b  d88P Y88..88P Y88b 888 Y8b.          888   888  888 888 Y88b.  
                   "Y8888P"   "Y88P"   "Y88888  "Y8888     8888888 888  888 888  "Y888 
                                                                                       
}
CON

  CODE_BASE = ( 32 - CODE_SIZE_KB ) * 1024

PRI FlushCode

  if debug & DEBUG_INIT
    Dbg( String( "INI FlushCode",$0D ) )

  codeBot := CODE_BASE
  codeTop := codeBot-1

  heapTop := codeBot-1
  heapBot := heapTop+1
  
  varsBot := codeTop+1
  varsTop := varsBot-1

  stakTop := $7FFF
  stakBot := stakTop+1

  byte[ codeBot ] := lookupAtTagEof

PRI ResetCode

  if debug & DEBUG_INIT
    Dbg( String( "INI ResetCode",$0D ) )

  ResetVars
  CondInit
  
  heapTop := codeBot-1
  heapBot := heapTop+1
  
  stakTop := $7FFF
  stakBot := stakTop+1

PRI ResetVars

  if debug & DEBUG_INIT
    Dbg( String( "INI ResetVars",$0D ) )

  codeTop := codeBot - 1
  if byte[ codeBot ] <> lookupAtTagEOF
    fileHandle := -1
    codeTop++
    repeat while byte[ codeTop ] <> lookupAtTagEOF
      codeTop := ListLine( codeTop )
  fileHandle := 0

  varsBot := codeTop+1
  varsTop := varsBot-1

DAT
{

         888                            888                .d8888b.                             
         888                            888               d88P  Y88b                            
         888                            888               Y88b.                                 
         888      .d88b.   8888b.   .d88888      888       "Y888b.    8888b.  888  888  .d88b.  
         888     d88""88b     "88b d88" 888    8888888        "Y88b.     "88b 888  888 d8P  Y8b 
         888     888  888 .d888888 888  888      888            "888 .d888888 Y88  88P 88888888 
         888     Y88..88P 888  888 Y88b 888               Y88b  d88P 888  888  Y8bd8P  Y8b.     
         88888888 "Y88P"  "Y888888  "Y88888                "Y8888P"  "Y888888   Y88P    "Y8888  

}

PRI LoadCodeFromEeprom

  LoadOrVerifyCodeFromEeprom( false )
  
PRI LoadOrVerifyCodeFromEeprom( isVerifying ) | n, nSize, nBlockSize, nCount

  if debug & DEBUG_INIT
    if isVerifying
      Dbg( String( "INI Verify" ) )
    else
      Dbg( String( "INI Load" ) )
  
  if IsAnythingSavedToEeprom
  
    FlushCode

    codeBot := i2c.ReadLong( @codeBot )
    codeTop := i2c.ReadLong( @codeTop )

    nBlockSize := BlockSize( nSize := codeTop-CodeBot )
    n := codeBot
    nCount := 0
    repeat
      Out( "*" )
      i2c.ReadByteArray( n, n, nBlockSize )
      n      += nBlockSize
      nCount += nBlockSize
    until n => codeTop

    OnNewLine

    if IsCodeLoadedSameAsCodeSaved
      if isVerifying
        Str( String( "Verified" ) )
      else
        Str( String( "Loaded" ) )
    else
      Str( String( "Failed" ) )
      FlushCode

  else
    Str( String( "None Saved" ) )
  
PRI SaveCodeToEeprom | n, nSize, nBlockSize, nCount

  if debug & DEBUG_INIT
    Dbg( String( "INI Save" ) )

  ResetCode
  If codeBot > codeTop
    Str( String( "No code" ) )
  else

    nBlockSize := BlockSize( nSize := codeTop-CodeBot )
    n := codeBot
    nCount := 0
    repeat
      Out( "*" )
      i2c.WriteByteArray( n, n, nBlockSize )
      n      += nBlockSize
      nCount += nBlockSize
    until n => codeTop

    SetCodeSavedToEeprom

    OnNewLine
    Str( String( "Saved",$0D ) )
    
    LoadOrVerifyCodefromEeprom( true )

PRI BlockSize( n )

  n /= 32
  result := 1
  repeat while result =< n
    result <<= 1

DAT
{

         .d8888b.  888                        888                                               
        d88P  Y88b 888                        888                                               
        888    888 888                        888                                               
        888        88888b.   .d88b.   .d8888b 888  888 .d8888b  888  888 88888b.d88b.  .d8888b  
        888        888 "88b d8P  Y8b d88P"    888 .88P 88K      888  888 888 "888 "88b 88K      
        888    888 888  888 88888888 888      888888K  "Y8888b. 888  888 888  888  888 "Y8888b. 
        Y88b  d88P 888  888 Y8b.     Y88b.    888 "88b      X88 Y88b 888 888  888  888      X88 
         "Y8888P"  888  888  "Y8888   "Y8888P 888  888  88888P'  "Y88888 888  888  888  88888P' 

                                                                                                
}
VAR

  long checksumLookup
  long checknotLookup
  
  long checksumVersion
  long checknotVersion

  long checksumCode
  long checknotCode

PRI IsAnythingSavedToEeprom

  result := ( i2c.ReadLong( @checksumLookup  ) == checksumLookup  ) and {
}           ( i2c.ReadLong( @checknotLookup  ) == checknotLookup  ) and {
}           ( i2c.ReadLong( @checksumVersion ) == checksumVersion ) and {
}           ( i2c.ReadLong( @checknotVersion ) == checknotVersion )

PRI SetCodeSavedToEeprom

  checknotCode := ! ( checksumCode := CalculateCodeChecksum )
  
  i2c.WriteLong( @codeBot         , codeBot         )
  i2c.WriteLong( @codeTop         , codeTop         )
    
  i2c.WriteLong( @checksumCode    , checksumCode    )
  i2c.WriteLong( @checknotCode    , checknotCode    )

  i2c.WriteLong( @checksumLookup  , checksumLookup  )
  i2c.WriteLong( @checknotLookup  , checknotLookup  ) 

  i2c.WriteLong( @checksumVersion , checksumVersion ) 
  i2c.WriteLong( @checknotVersion , checknotVersion )

PRI IsCodeLoadedSameAsCodeSaved

  checknotCode := ! ( checksumCode := CalculateCodeChecksum )

  result := ( IsAnythingSavedToEeprom                          ) and {
}           ( i2c.ReadLong( @codeBot        ) == codeBot       ) and {
}           ( i2c.ReadLong( @codeTop        ) == codeTop       ) and {
}           ( i2c.ReadLong( @checksumCode   ) == checksumCode  ) and {
}           ( i2c.ReadLong( @checknotCode   ) == checknotCode  ) 
  
PRI CalculateCodeChecksum | n

  ResetCode
  result := checksumLookup + MAGIC_NUMBER
  if codeTop => codeBot
    repeat n from codeBot to codeTop
       result += byte[ n ]

DAT
{                                                                                       

       .d8888b.                888             888      d8b          888    d8b                   
      d88P  Y88b               888             888      Y8P          888    Y8P                   
      888    888               888             888                   888                          
      888         .d88b.   .d88888  .d88b.     888      888 .d8888b  888888 888 88888b.   .d88b.  
      888        d88""88b d88" 888 d8P  Y8b    888      888 88K      888    888 888 "88b d88P"88b 
      888    888 888  888 888  888 88888888    888      888 "Y8888b. 888    888 888  888 888  888 
      Y88b  d88P Y88..88P Y88b 888 Y8b.        888      888      X88 Y88b.  888 888  888 Y88b 888 
       "Y8888P"   "Y88P"   "Y88888  "Y8888     88888888 888  88888P'  "Y888 888 888  888  "Y88888 
                                                                                              888 
                                                                                         Y8b d88P 
                                                                                          "Y88P"  
}
VAR

  word listFrom
  word listCount

  byte listNeedSpace
  
PRI ListLines( n, nCount )

  if ( listFrom := n ) == 0
    listFrom := codeBot

  listCount := nCount
  repeat
    listFrom := ListLine(listFrom)
  until byte[ listFrom ] == lookupAtTagEOF or --nCount == 0
  
  if byte[ listFrom ] == lookupAtTagEOF
    listFrom := 0
      
PRI ListLine( n )

  listNeedSpace := false
  numberRadix := 10
  repeat while ( result := opcLookupTable[ byte[ n++ ] ] ) <> @tagEOL
    n := ListToken( n, result )
  Out( $0D )
  result := n

PRI ListToken( n, thisW )

  if listNeedSpace~~
    Out( " " )
  case thisW
    @tagCHAR :
      Out( $22 )
      ListTextChar( byte[ n++ ] )
      Out( $22 )
    @tagBYTE :
      OutNumberFormat( byte[ n++ ] , numberRadix, 0 )
      numberRadix := 10
    @tagWORD :
      OutNumberFormat( byte[ n++ ] << 8 | byte[ n++ ] ,numberRadix, 0 )
      numberRadix := 10
    @tagTRIP :
      OutNumberFormat( byte[ n++ ] << 16 | byte[ n++ ] << 8 | byte[ n++ ] ,numberRadix, 0)
      numberRadix := 10
    @tagNUMBER :
      OutNumberFormat( byte[ n++ ] << 24 | byte[ n++ ] << 16 | byte[ n++ ] << 8 | byte[ n++ ] , numberRadix, 0 )
      numberRadix := 10
    @tagVAR, @tagNEW:
      if fileHandle < 0
        byte[ n-1 ] := lookupAtTagNEW
        byte[ n++ ] := 0
        byte[ n++ ] := 0
      else
        n += 2
      repeat
        Out( ( result := byte[ n++ ] ) & $7F )
      while ( result & $80 )
    @tagREG :
      StrChoice( @regNames, byte[ n++ ] & $F )
    @tagTXT:
      Out( $22 )
      repeat
        if ( result := byte[ n++ ] ) & $7F
          ListTextChar( result & $7F )
      while ( result & $80 )
      Out( $22 )
    @tagREM :
      Out( "'" )
      repeat
        if ( result := byte[ n++ ] ) & $7F
          Out( result & $7F )
      while ( result & $80 )
    @tagSPC :
      repeat byte[ n++ ]
        Out( " " )
    @tagBIN :
      numberRadix := 2
      Out( "%" )
      listNeedSpace := 0 
    @tagHEX :
      numberRadix := 16
      Out( "$" )
      listNeedSpace := 0
    @opcGOTO, @opcGOSUB :
      if fileHandle < 0
        byte[ n++ ] := 0
        byte[ n++ ] := 0
      else
        n += 2
      Str( thisW )
    other :
      Str( thisW )

  result := n

PRI ListTextChar( n )

  if n == $22
    Out( $22 )
  Out( n )

PRI ListVars

  if MemInfo( MEM_VARS | MEM_USE )

  else
    Str( String( "None" ) )

DAT
{

               .d8888b.                888             888     888 888    d8b 888          
              d88P  Y88b               888             888     888 888    Y8P 888          
              888    888               888             888     888 888        888          
              888         .d88b.   .d88888  .d88b.     888     888 888888 888 888 .d8888b  
              888        d88""88b d88" 888 d8P  Y8b    888     888 888    888 888 88K      
              888    888 888  888 888  888 88888888    888     888 888    888 888 "Y8888b. 
              Y88b  d88P Y88..88P Y88b 888 Y8b.        Y88b. .d88P Y88b.  888 888      X88 
               "Y8888P"   "Y88P"   "Y88888  "Y8888      "Y88888P"   "Y888 888 888  88888P' 
                                                                                           
}
VAR

  long codeBot
  long codeTop

PRI PushOpc( n )

  if pc == 0
    pc := codeBot
    
  byte[ pc++ ] := GetFromOpcLookupTable( n )
  if n == @opcGOTO or n == @opcGOSUB
    byte[ pc++ ] := 0
    byte[ pc++ ] := 0
  
PRI PushVar( strPtr )

  PushOpc( @tagNEW )    
  byte[ pc++ ] := 0
  byte[ pc++ ] := 0
  repeat StrSize( strPtr ) - 1
    byte[ pc++ ] := byte[ strPtr++ ] | $80
  byte[ pc++ ] := byte[ strPtr ]
    
PRI PushNum( n )

  if n & $FF00_0000
    PushOpc( @tagNUMBER )
    byte[ pc++ ] := n >> 24
    byte[ pc++ ] := n >> 16
    byte[ pc++ ] := n >> 8
    byte[ pc++ ] := n
  else
    if n & $FFFF_0000
      PushOpc( @tagTRIP )
      byte[ pc++ ] := n >> 16
      byte[ pc++ ] := n >> 8
      byte[ pc++ ] := n
    else
      if n & $FFFF_FF00
        PushOpc( @tagWORD )
        byte[ pc++ ] := n >> 8
        byte[ pc++ ] := n
      else
        PushOpc( @tagBYTE )
        byte[ pc++ ] := n

PRI PushTxt( strPtr )

  PushOpc( @tagTXT )
  if strPtr <> 0 and StrSize( strPtr )
    repeat StrSize( strPtr ) - 1
      byte[ pc++ ] := byte[ strPtr++ ] | $80
    byte[ pc++ ] := byte[ strPtr ]
  else
    byte[ pc++ ] := 0

PRI PushReg( n )

  PushOpc( @tagREG )
  byte[ pc ++ ] := n
  
DAT
{

 888      d8b                                                      888     888 888    d8b 888          
 888      Y8P                                                      888     888 888    Y8P 888          
 888                                                               888     888 888        888          
 888      888 88888b.   .d88b.  88888b.  888  888 88888b.d88b.     888     888 888888 888 888 .d8888b  
 888      888 888 "88b d8P  Y8b 888 "88b 888  888 888 "888 "88b    888     888 888    888 888 88K      
 888      888 888  888 88888888 888  888 888  888 888  888  888    888     888 888    888 888 "Y8888b. 
 888      888 888  888 Y8b.     888  888 Y88b 888 888  888  888    Y88b. .d88P Y88b.  888 888      X88 
 88888888 888 888  888  "Y8888  888  888  "Y88888 888  888  888     "Y88888P"   "Y888 888 888  88888P' 
                                                                         
}

PRI PreCachedLineNumber | nV, nLastPc

  nV := v
  nLastPc := lastPc
  Token
  result := LineNumberPc( nV, nLastPc )
  
PRI LineNumber

  result := LineNumberPc( 0, 0 )
  
PRI LineNumberPc( cached, nPc ) | n

' if GOTO * / GOSUB * then a variable is assumed t hold the address of the line to goto

  result := cached ' Remember any pre-cached value

  if w == @symMPY
    Token
    VarRef
    result := varValue
  else
    if cached
      ExprLineNumber
    else
      if ( n := ExprLineNumber )
        fileHandle := -1
        result := FindLineNumberPc( n )
        fileHandle := 0
        if nPc
          byte[ nPc + 1 ] := result >> 8
          byte[ nPc + 2 ] := result
      else
        result := codeBot

PRI ExprLineNumber

  if ( result := PositiveNumber ) > 99999
    Abort @AboINVALID_LINENUMBER

PRI FindLineNumberPc( argLineNumber ) | nPc, nLinenumber

  nLineNumber := 0
  nPc := codeBot
  repeat

    case opcLookupTable[ byte[ nPc ] ]
      @tagBYTE :
        nLineNumber := byte[ nPc+1 ]
      @tagWORD :
        nLineNumber := byte[ nPc+1 ] << 8  | byte[ nPc+2 ]
      @tagTRIP :
        nLineNumber := byte[ nPc+1 ] << 16 | byte[ nPc+2 ] << 8  | byte[ nPc+3 ]
      @tagNUMBER :
        nLineNumber := byte[ nPc+1 ] << 24 | byte[ nPc+2 ] << 16 | byte[ nPc+3 ] << 8 | byte[ nPc+4 ]
      @tagEOF :
        Abort @aboINVALID_LINENUMBER

   if nLineNumber == argLineNumber
     return nPc

   nPc := ListLine( nPc )
     
  
DAT
{

           .d8888b.  888                      888         888     888 888    d8b 888          
          d88P  Y88b 888                      888         888     888 888    Y8P 888          
          Y88b.      888                      888         888     888 888        888          
           "Y888b.   888888  8888b.   .d8888b 888  888    888     888 888888 888 888 .d8888b  
              "Y88b. 888        "88b d88P"    888 .88P    888     888 888    888 888 88K      
                "888 888    .d888888 888      888888K     888     888 888    888 888 "Y8888b. 
          Y88b  d88P Y88b.  888  888 Y88b.    888 "88b    Y88b. .d88P Y88b.  888 888      X88 
           "Y8888P"   "Y888 "Y888888  "Y8888P 888  888     "Y88888P"   "Y888 888 888  88888P' 
                                                                                              
}

VAR

  long stakBot
  long stakTop
  long holeMrk
  
PRI PushByte( n )

  byte[ --stakBot ] := n

PRI PushWord( n )

  PushByte( n )
  PushByte( n >> 8)

PRI PushLong( n )

  PushWord( n )
  PushWord( n >> 16 )

PRI PopByte

  result := byte[ stakBot++ ]

PRI PopWord

  result := PopByte << 8 | PopByte

PRI PopLong

  result := PopWord << 16 | PopWord
  
DAT
{

              888    888                               888     888 888    d8b 888          
              888    888                               888     888 888    Y8P 888          
              888    888                               888     888 888        888          
              8888888888  .d88b.   8888b.  88888b.     888     888 888888 888 888 .d8888b  
              888    888 d8P  Y8b     "88b 888 "88b    888     888 888    888 888 88K      
              888    888 88888888 .d888888 888  888    888     888 888    888 888 "Y8888b. 
              888    888 Y8b.     888  888 888 d88P    Y88b. .d88P Y88b.  888 888      X88 
              888    888  "Y8888  "Y888888 88888P"      "Y88888P"   "Y888 888 888  88888P' 
                                           888                                             
                                           888                                             
                                           888                                             

}
VAR

  long heapBot
  long heapTop

DAT
{

 888b     d888                                                     888     888 888    d8b 888          
 8888b   d8888                                                     888     888 888    Y8P 888          
 88888b.d88888                                                     888     888 888        888          
 888Y88888P888  .d88b.  88888b.d88b.   .d88b.  888d888 888  888    888     888 888888 888 888 .d8888b  
 888 Y888P 888 d8P  Y8b 888 "888 "88b d88""88b 888P"   888  888    888     888 888    888 888 88K      
 888  Y8P  888 88888888 888  888  888 888  888 888     888  888    888     888 888    888 888 "Y8888b. 
 888   "   888 Y8b.     888  888  888 Y88..88P 888     Y88b 888    Y88b. .d88P Y88b.  888 888      X88 
 888       888  "Y8888  888  888  888  "Y88P"  888      "Y88888     "Y88888P"   "Y888 888 888  88888P' 
                                                            888                                        
                                                       Y8b d88P                                        
                                                        "Y88P"                                         

}
CON
{

                .-----------.
        0000    |           |
                |           |   Main Interpreter ( Spin )
                |           |
                |-----.-----|
                |     |     |
                |    \|/    |   Interpreter Stack ( Spin )
                |           |
                | - - - - - |
                |           |   Hole
                | - - - - - |
                |           |
                |    /|\    |   User Heap
        3FFF    |     |     |
                |-----^-----|
        4000    |           |
                |           |   User Code
                |           |
                |-----------|
                |           |   User Allocated Space ( may not exist )
                |-----.-----|
                |     |     |
                |    \|/    |   User Variables
                |           |
                | - - - - - |
                |           |   Free
                | - - - - - |
                |           |
                |    /|\    |   User Stack
        7FFF    |     |     |
                `-----^-----'

}
CON

    MEM_BASE    = 0 << 2
    MEM_HOLE    = 1 << 2
    MEM_HEAP    = 2 << 2
    MEM_CODE    = 3 << 2
    MEM_VARS    = 4 << 2
    MEM_USER    = 5 << 2
    MEM_FREE    = 6 << 2
    MEM_STAK    = 7 << 2
    
    MEM_TXT     = 0
    MEM_BOT     = 1
    MEM_TOP     = 2
    MEM_USE     = 3

PRI ListMemory( showAll ) | n

  if showAll
    n := MEM_BASE
  else
    n := MEM_BASE ' @@@@@ MEM_HEAP when we've finished debugging

  repeat while n =< MEM_STAK
    if MemInfo( n | MEM_USE ) or showAll
      Str( MemInfo( n | MEM_TXT ) )
      Str( String( "  " ) )
      Hex( MemInfo( n | MEM_BOT ), 4 )
      Str( String( " .. " ) )
      Hex( MemInfo( n | MEM_TOP ), 4 )
      Str( String( "  " ) )
      Dkb( MemInfo( n | MEM_USE ) )
      if n == MEM_BASE
        Str( String( " ( " ) )
        Hex( @result, 4 )
        Str( String( " )" ) )
      Out( $0D )
    n += 4
    
PRI MemInfo( n )

  if @result > holeMrk
    holeMrk := @result

  case n
  
    MEM_BASE | MEM_TXT : result := String( "Base" )
    MEM_BASE | MEM_BOT : result := 0
    MEM_BASE | MEM_TOP : result := holeMrk | 1023

    MEM_HOLE | MEM_TXT : result := String( "Hole" )
    MEM_HOLE | MEM_BOT : result := ( holeMrk | 1023 ) + 1
    MEM_HOLE | MEM_TOP : result := heapBot - 1

    MEM_HEAP | MEM_TXT : result := String( "Heap" )
    MEM_HEAP | MEM_BOT : result := HeapBot
    MEM_HEAP | MEM_TOP : result := codeBot-1

    MEM_CODE | MEM_TXT : result := String( "Code" )
    MEM_CODE | MEM_BOT : result := codeBot
    MEM_CODE | MEM_TOP : result := codeTop

    MEM_USER | MEM_TXT : result := String( "User" )
    MEM_USER | MEM_BOT : result := codeTop + 1
    MEM_USER | MEM_TOP : result := varsBot - 1

    MEM_VARS | MEM_TXT : result := String( "Vars" )
    MEM_VARS | MEM_BOT : result := varsBot
    MEM_VARS | MEM_TOP : result := varsTop

    MEM_FREE | MEM_TXT : result := String( "Free" )
    MEM_FREE | MEM_BOT : result := varsTop + 1
    MEM_FREE | MEM_TOP : result := stakBot - 1

    MEM_STAK | MEM_TXT : result := String( "Stak" )
    MEM_STAK | MEM_BOT : result := stakBot
    MEM_STAK | MEM_TOP : result := stakTop    
    
    other              : n &= %111_00
                         result := MemInfo( n+2 ) - MemInfo( n+1 ) + 1

DAT
{

                   888     888                    888     888 888    d8b 888          
                   888     888                    888     888 888    Y8P 888          
                   888     888                    888     888 888        888          
                   Y88b   d88P 8888b.  888d888    888     888 888888 888 888 .d8888b  
                    Y88b d88P     "88b 888P"      888     888 888    888 888 88K      
                     Y88o88P  .d888888 888        888     888 888    888 888 "Y8888b. 
                      Y888P   888  888 888        Y88b. .d88P Y88b.  888 888      X88 
                       Y8P    "Y888888 888         "Y88888P"   "Y888 888 888  88888P' 
                                                                                      
}
CON

  #0
        VAR_VARADR              ' Where the var definition is in memory
        VAR_VALADR              ' Where the variables's values are held
        VAR_NAMADR              ' Where the variabe's name is
        VAR_NXTADR              ' Where the enxt variable is
  VAR_NAMLEN                    ' How many bytes in the name
  VAR_VARSIZ                    ' Fundamental size of the variable - 1, 2 or 4
        VAR_BYTSIZ              ' How many bytes of value are there
        VAR_VCOUNT              ' How many variables
        VAR_IDXMAX              ' Maximum Index allowed
        VAR_VARVAL              ' What the variable's value is ( or var(0)'s value )

VAR

  byte tmpVarSpace[16] ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  
VAR

  long varsBot
  long varsTop

PRI VarFunc( n1, n )

  result := VarInfo( 0, n ) ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  
PRI VarInfo( nPtr, n )

  case n
    VAR_VARADR : result := nPtr
    VAR_VALADR : result := nPtr + 2
    VAR_NAMADR : result := nPtr + 2 + VarInfo( nPtr, VAR_BYTSIZ )
    VAR_NXTADR : result := nPtr + 2 + VarInfo( nPtr, VAR_BYTSIZ ) + VarInfo( nPtr, VAR_NAMLEN )
    VAR_BYTSIZ : result := byte [ nPtr ] << 8 | byte[ nPtr+1 ]
    VAR_VCOUNT : result := ( VarInfo( nPtr, VAR_BYTSIZ ) / VarInfo( nPtr, VAR_VARSIZ ) )
    VAR_IDXMAX : result := VarInfo( nPtr, VAR_VCOUNT ) - 1
    VAR_VARVAL : result := PeekVar( nPtr + 2, VarInfo( nPtr, VAR_VARSIZ ) )
'    VAR_NAMLEN :           ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ 
'    VAR_VARSIZ :           ' @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'                 result := GetVarSizeFromType( .... ) 
    other      : Abort @aboINVALID_VALUE

PRI GetVarSizeFromType( n )

  case n & $7F
    "%"      : result := 1
    "&", "$" : result := 2
    other    : result := 4

PRI CreateVar | varPtr

  if w == @tagNEW

    result := @tmpVarSpace + 4

    byte[ v-1 ] := lookupAtTagVAR
    byte[ v   ] := result >> 8
    byte[ v+1 ] := result
  else
    result := byte[ v ] << 8 | byte[ v+1 ]

DAT
{

    8888888888                                                   888     888 888    d8b 888          
    888                                                          888     888 888    Y8P 888          
    888                                                          888     888 888        888          
    8888888    .d88b.  88888b.  888d888 .d88b.  88888b.d88b.     888     888 888888 888 888 .d8888b  
    888       d8P  Y8b 888 "88b 888P"  d88""88b 888 "888 "88b    888     888 888    888 888 88K      
    888       88888888 888  888 888    888  888 888  888  888    888     888 888    888 888 "Y8888b. 
    888       Y8b.     888 d88P 888    Y88..88P 888  888  888    Y88b. .d88P Y88b.  888 888      X88 
    8888888888 "Y8888  88888P"  888     "Y88P"  888  888  888     "Y88888P"   "Y888 888 888  88888P' 
                       888                                                                           
                       888                                                                           
                       888                                                                           

}
VAR

  byte eepromCount
  
PRI CountEeproms | n

  if eepromCount == 0                                   ' Don't know how many Eeproms
    EepromOpen( 2 )                                     ' Open the second Eeprom which may not be there
    n := ! i2c.ReadLong( 0 )                            ' Read inverted data from address 0
    i2c.WriteLong( 0 , n )                              ' And put that back
    if ( result := ( n == i2c.ReadLong( 0 ) ) )         ' Flag if we can read what we wrote
      i2c.WriteLong( 0 , ! n )                          ' Restore original byte in address 0
    EepromClose                                         ' And we've finished with the second bank
    EepromOpen( eepromCount := 1 )                      ' Now, in the first bank
    if result
      eepromCount := 2                                  ' Indicate there are two Eeproms
    i2c.WriteByte( @eepromCount, eepromCount )    

PRI EepromOpen( bank ) ' bank = 1..N ( 0 == 1 )

  i2c.Open( I2C_SCL_PIN, I2C_SDA_PIN, i2c#EEPROM_24LC256, bank )

PRI EepromClose

  i2c.Close

PRI ListEeprom

  CountEeproms
  Dec( eepromCount )
  Out( $0D )
    
DAT
{

             8888888b.           888                                 d8b                   
             888  "Y88b          888                                 Y8P                   
             888    888          888                                                       
             888    888  .d88b.  88888b.  888  888  .d88b.   .d88b.  888 88888b.   .d88b.  
             888    888 d8P  Y8b 888 "88b 888  888 d88P"88b d88P"88b 888 888 "88b d88P"88b 
             888    888 88888888 888  888 888  888 888  888 888  888 888 888  888 888  888 
             888  .d88P Y8b.     888 d88P Y88b 888 Y88b 888 Y88b 888 888 888  888 Y88b 888 
             8888888P"   "Y8888  88888P"   "Y88888  "Y88888  "Y88888 888 888  888  "Y88888 
                                                        888      888                   888 
                                                   Y8b d88P Y8b d88P              Y8b d88P 
                                                    "Y88P"   "Y88P"                "Y88P"  

}
CON

  DEBUG_SHOWEXPR                = |< 0
  DEBUG_SHOWLINE                = |< 1
  DEBUG_SHOWTOKEN               = |< 2
  DEBUG_ALLTOKENS               = |< 3
  DEBUG_SHOWVARDEF              = |< 4
  DEBUG_GAVELNUM                = |< 5
  DEBUG_INIT                    = |< 6
  
VAR                   

  long debug

PRI Dbg( strPtr )

  OnNewLine
  Out( "#" )
  Str( strPtr )
  if notHadCrLf
    Out( " " )
       
DAT
{

          88888888888       888                           888     888 888    d8b 888          
              888           888                           888     888 888    Y8P 888          
              888           888                           888     888 888        888          
              888   .d88b.  888  888  .d88b.  88888b.     888     888 888888 888 888 .d8888b  
              888  d88""88b 888 .88P d8P  Y8b 888 "88b    888     888 888    888 888 88K      
              888  888  888 888888K  88888888 888  888    888     888 888    888 888 "Y8888b. 
              888  Y88..88P 888 "88b Y8b.     888  888    Y88b. .d88P Y88b.  888 888      X88 
              888   "Y88P"  888  888  "Y8888  888  888     "Y88888P"   "Y888 888 888  88888P' 

}

CON

  MAX_OPCODES = 220
  
VAR

  word opcLookupTable[ MAX_OPCODES ]

  byte lookupAtTagEOF
  byte lookupAtTagNEW
  byte lookupAtTagVAR

PRI BuildOpcLookupTable | n
  
  checksumLookup := 0
  n := @opc_LIST_START
  repeat while n < @tag_LIST_END
    if byte[ n ]
      if result => MAX_OPCODES
        Str( String("Too many opcodes") )
        repeat
      checksumLookup <-= 3
      opcLookupTable[ result++ ] := n
      repeat while byte[ n ]
        checksumLookup += byte[ n++ ]
    n++
      
  lookupAtTagEOF := GetFromOpcLookupTable( @tagEOF )
  lookupAtTagNEW := GetFromOpcLookupTable( @tagNEW )
  lookupAtTagVAR := GetFromOpcLookupTable( @tagVAR )

  checksumVersion := checksumLookup <- 5
  n := Version
  repeat StrSize( n )
    checksumVersion -= byte[ n++ ]

  checknotLookup  := ! checksumLookup
  checknotVersion := ! checksumVersion
    
PRI GetFromOpcLookupTable( n )

  repeat while opcLookupTable[ result ] <> n
    result++
    
DAT
{

  88888888888       888                           888b    888                                          
      888           888                           8888b   888                                          
      888           888                           88888b  888                                          
      888   .d88b.  888  888  .d88b.  88888b.     888Y88b 888  8888b.  88888b.d88b.   .d88b.  .d8888b  
      888  d88""88b 888 .88P d8P  Y8b 888 "88b    888 Y88b888     "88b 888 "888 "88b d8P  Y8b 88K      
      888  888  888 888888K  88888888 888  888    888  Y88888 .d888888 888  888  888 88888888 "Y8888b. 
      888  Y88..88P 888 "88b Y8b.     888  888    888   Y8888 888  888 888  888  888 Y8b.          X88 
      888   "Y88P"  888  888  "Y8888  888  888    888    Y888 "Y888888 888  888  888  "Y8888   88888P' 

}
DAT
DAT

opc_LIST_START

opcABS                  byte    "Abs",0
opcLOGAND               byte    "And",0
opcAS                   byte    "As",0
opcBIN                  byte    "Bin",0
opcBREAK                byte    "Break",0
opcBYTE                 byte    "Byte",0
'opcCALL                 byte    "Call",0
'opcCASE                 byte    "Case",0
opcCHIPVER              byte    "ChipVer",0
'opcCHR                  byte    "Chr",0
opcCLKFREQ              byte    "ClkFreq",0
opcCLOSE                byte    "Close",0
opcCLS                  byte    "Cls",0
opcCOGS                 byte    "Cogs",0
opcCOLOR                byte    "Color",0
opcCOLOUR               byte    "Colour",0
opcCOLUMN               byte    "Column",0
opcDATA                 byte    "Data",0
'opcDEBUG                byte    "Debug",0
opcDEC                  byte    "Dec",0
'opcDEF                  byte    "Def",0
opcDIM                  byte    "Dim",0
'opcDIR                  byte    "Dir",0
opcEEPROM               byte    "Eeprom",0
opcELSE                 byte    "Else",0
opcELSEIF               byte    "ElseIf",0
opcEND                  byte    "End",0
'opcENDDEF               byte    "EndDef",0
'opcENDFUNC              byte    "EndFunction",0
opcENDIF                byte    "EndIf",0
'opcENDSELECT            byte    "EndSelect",0
'opcENDSUB               byte    "EndSub",0
'opcEOF                  byte    "Eof",0
'opcERROR                byte    "Error",0
'opcEXIT                 byte    "Exit",0
opcFALSE                byte    "False",0
opcFOR                  byte    "For",0
'opcFUNCTION             byte    "Function",0
opcGOSUB                byte    "Gosub",0
opcGOTO                 byte    "Goto",0
opcHELP                 byte    "Help",0
opcHEX                  byte    "Hex",0
opcHIGH                 byte    "High",0              
opcHIGHEST              byte    "Highest",0
opcIF                   byte    "If",0
'opcIN                   byte    "In",0
opcINKEY                byte    "InKey",0
opcINPUT                byte    "Input",0
opcIS                   byte    "Is",0
'opcKILL                 byte    "Kill",0
opcLET                  byte    "Let",0
opcLIST                 byte    "List",0
opcLOAD                 byte    "Load",0
opcLOCATE               byte    "Locate",0
'opcLOF                  byte    "Lof",0
opcLONG                 byte    "Long",0
opcLOW                  byte    "Low",0
opcLOWEST               byte    "Lowest",0
opcLSB                  byte    "Lsb",0
opcLSW                  byte    "Lsw",0
opcMAX                  byte    "Max",0
opcMEM                  byte    "Mem",0
opcMIN                  byte    "Min",0
opcMOD                  byte    "Mod",0
'opcMODE                 byte    "Mode",0
opcMSB                  byte    "Msb",0
opcMSW                  byte    "Msw",0
'opcNAME                 byte    "Name",0
opcLOGNAND              byte    "Nand",0
opcNEW                  byte    "New",0
'opcNEXT                 byte    "Next",0
opcLOGNOR               byte    "Nor",0
opcLOGNOT               byte    "Not",0
opcLOGNXOR              byte    "Nxor",0
'opcON                   byte    "On",0
opcOPEN                 byte    "Open",0
opcLOGOR                byte    "Or",0
'opcOTHER                byte    "Other",0
opcOUTPUT               byte    "Output",0
opcPAUSE                byte    "Pause",0
'opcPOP                  byte    "Pop",0
opcPRINT                byte    "Print",0
'opcPUSH                 byte    "Push",0
'opcQUIT                 byte    "Quit",0
opcRANDOM               byte    "Random",0
opcREAD                 byte    "Read",0
opcRENUM                byte    "ReNum",0
opcREPEAT               byte    "Repeat",0
opcRESTORE              byte    "Restore",0
'opcRESULT               byte    "Result",0
opcRETURN               byte    "Return",0
opcROW                  byte    "ROW",0
opcRUN                  byte    "Run",0
opcSAVE                 byte    "Save",0
'opcSEEK                 byte    "Seek",0
'opcSELECT               byte    "Select",0
'opcSHELL                byte    "Shell",0
opcSPR                  byte    "SPR",0
opcSQR                  byte    "Sqr",0
'opcSTART                byte    "Start",0
'opcSTEP                 byte    "Step",0
'opcSTOP                 byte    "Stop",0
opcSTR                  byte    "Str",0
'opcSUB                  byte    "Sub",0
'opcSYSTEM               byte    "System",0
opcTHEN                 byte    "Then",0
'opcTAB                  byte    "Tab",0
'opcTO                   byte    "To",0
opcTOGGLE               byte    "Toggle",0
opcTRUE                 byte    "True",0
opcUNTIL                byte    "Until",0
opcUSER                 byte    "User",0
opxVAR                  byte    "Var",0
opcVARS                 byte    "Vars",0
opcWAITCNT              byte    "WaitCnt",0
opcWAITPEQ              byte    "WaitPeq",0
opcWAITPNE              byte    "WaitPne",0
opcWEND                 byte    "Wend",0
opcWHILE                byte    "While",0
opcWORD                 byte    "Word",0
opcLOGXNOR              byte    "Xnor",0
opcLOGXOR               byte    "Xor",0

opc_LIST_END            byte    0

DAT
DAT

sym_LIST_START

symABS                  byte    "||",0
symADD                  byte    "+",0
symADDEQ                byte    "+=",0
symAND                  byte    "&",0
symANDEQ                byte    "&=",0
symANDNOT               byte    "&/",0
symANDNOTEQ             byte    "&/=",0
symASR                  byte    "~>",0
symASREQ                byte    "~>=",0
symAT                   byte    "@",0
symBIT                  byte    "|<",0
symCOLON                byte    ":",0
symCOLONEQ              byte    ":=",0
symCOMMA                byte    ",",0
symDEC                  byte    "--",0
symDIV                  byte    "/",0
symDIVEQ                byte    "/=",0
symDOT                  byte    ".",0
symDOTDOT               byte    "..",0
symEG                   byte    "=>",0
symEL                   byte    "=<",0
symEQ                   byte    "=",0
symEQEQ                 byte    "==",0
symGE                   byte    ">=",0
symGT                   byte    ">",0
symHASH                 byte    "#",0
symINC                  byte    "++",0
symLBRACE               byte    "{",0,"{",0
symLBRACKET             byte    "[",0
symLE                   byte    "<=",0
symLPARA                byte    "(",0
symLT                   byte    "<",0
symMAX                  byte    "<#",0
symMAXEQ                byte    "<#=",0
symMIN                  byte    "#>",0
symMINEQ                byte    "#>=",0
symMOD                  byte    "//",0
symMODEQ                byte    "//=",0
symMPY                  byte    "*",0
symMPYEQ                byte    "*=",0
symNAND                 byte    "/&",0
symNANDEQ               byte    "/&=",0
symNE                   byte    "<>",0
symNOR                  byte    "/|",0
symNOREQ                byte    "/|=",0
symNOT                  byte    "!",0
symNOTEQ                byte    "!=",0
symOR                   byte    "|",0
symOREQ                 byte    "|=",0
symORNOT                byte    "|/",0
symORNOTEQ              byte    "|/=",0
symPCT                  byte    "%",0
symPCTEQ                byte    "%=",0
symRND                  byte    "?",0
symRBRACE               byte    "}",0
symRBRACKET             byte    "]",0
symREV                  byte    "><",0
symREVEQ                byte    "><=",0
symROL                  byte    "<-",0
symROLEQ                byte    "<-=",0
symROR                  byte    "->",0
symROREQ                byte    "->=",0
symRPARA                byte    ")",0
symSEMICOLON            byte    ";",0
symSHL                  byte    "<<",0
symSHLEQ                byte    "<<=",0
symSHR                  byte    ">>",0
symSHREQ                byte    ">>=",0
symSQR                  byte    "^^",0
symSUB                  byte    "-",0
symSUBEQ                byte    "-=",0
symSXB                  byte    "~",0
symSXW                  byte    "~~",0
symXNOR                 byte    "/^",0
symXNOREQ               byte    "/^=",0
symXOR                  byte    "^",0
symXOREQ                byte    "^=",0
symXORNOT               byte    "^/",0
symXORNOTEQ             byte    "^/=",0

sym_LIST_END            byte      0

DAT
DAT

tag_LIST_START
                                
tagBIN                  byte    "{BIN}",0
tagBYTE                 byte    "{BYT}",0
tagCHAR                 byte    "{CHR}",0
tagEOF                  byte    "{EOF}",0
tagEOL                  byte    "{EOL}",$0D,0,"End of line",0   
tagHEX                  byte    "{HEX}",0
tagNEW                  byte    "{NEW}",0
tagNUMBER               byte    "{NUM}",0,"Number",0
tagREG                  byte    "{REG}",0,"Register",0
tagREM                  byte    "{REM}",0
tagSPC                  byte    "{SPC}",0
tagTRIP                 byte    "{TRP}",0
tagTXT                  byte    "{TXT}",0,"String",0
tagVAR                  byte    "{VAR}",0,"Variable",0
tagWORD                 byte    "{WRD}",0

tag_LIST_END  

DAT
DAT

aboFINISHED             byte    "Finished",0
aboSYNTAX_ERROR         byte    "Syntax Error",0
aboUNIMPLEMENTED        byte    "Unimplemented",0
aboNESTING_ERROR        byte    "Nesting Error",0
aboNESTING_TOO_DEEP     byte    "Nesting Too Deep",0
aboFACTOR_EXPECTED      byte    "*Variable or Constant",0
aboSTATEMENT_EXPECTED   byte    "*Statement",0
aboBAD_DIM_SIZE         byte    "Bad Dim Size",0
aboINVALID_VALUE        byte    "Invalid Value",0
aboINVALID_LINENUMBER   byte    "Invalid Line Number",0
aboALREADY_DEFINED      byte    "Already Defined",0
aboINVALID_ARRAY_INDEX  byte    "Invalid Array Index",0
aboNEEDS_ARRAY_INDEX    byte    "*Array Index",0
aboMODIFIER_ERROR       byte    "Type Modifier Error",0
aboFELL_OFF_END         byte    "Reached end of code",0
aboFILE_OPEN            byte    "File Open",0
aboPIN_IN_USE           byte    "Pin In Use",0
aboINPUT_IN_USE         byte    "Input n use",0
aboBAD_FILE_MODE        byte    "Bad File Mode",0

DAT
DAT

regNames                byte    "PAR",0         ' $1F0
                        byte    "CNT",0         ' $1F1
                        byte    "INA",0         ' $1F2
                        byte    "INB",0         ' $1F3
                        byte    "OUTA",0        ' $1F4
                        byte    "OUTB",0        ' $1F5
                        byte    "DIRA",0        ' $1F6
                        byte    "DIRB",0        ' $1F7
                        byte    "CTRA",0        ' $1F8
                        byte    "CTRB",0        ' $1F9
                        byte    "FRQA",0        ' $1FA
                        byte    "FRQB",0        ' $1FB
                        byte    "PHSA",0        ' $1FC
                        byte    "PHSB",0        ' $1FD
                        byte    "VCFG",0        ' $1FE
                        byte    "VSCL",0        ' $1FF

DAT

{

                              888                 8888888888 d8b          
                              888                 888        Y8P          
                              888                 888                     
                              888      .d88b.     8888888    888 88888b.  
                              888     d8P  Y8b    888        888 888 "88b 
                              888     88888888    888        888 888  888 
                              888     Y8b.        888        888 888  888 
                              88888888 "Y8888     888        888 888  888

}
DAT
{

ASCII banners from ...

http://www.network-science.de/ascii/

Font: colossal
Reflection: no
Adjustment: center
Stretch: no
Width: 105

Font: serifcap
Reflection: no
Adjustment: left
Stretch: no
Width: 105

}